/****************************************************************************
 *	acconv: Athena Widget -> Code Conveterter
 *			~                ~    ~~~~
 *			Date. 1995/11/18 -- 1995/12/29
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************************
 *	øɸ饤֥Υ󥯥롼ɥե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include <unistd.h>
/*************************************
 *	X Toolkit Υ󥯥롼ɥե
 *************************************/
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Xlocale.h>
#include <X11/Core.h>
#include <X11/Shell.h>
#include <X11/Xatom.h>
#include <X11/Xmu/Atoms.h>
#include <X11/bitmaps/xlogo11>
/* #include <X11/bitmaps/xlogo64> */

/*****************************************
 *	Athena Widget Υ󥯥롼ɥե
 *****************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Panner.h>
#include <X11/Xaw/Porthole.h>
#include <X11/Xaw/Tree.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>

/***********************************************
 *	ץꥱѥ󥯥롼ɥե
 ***********************************************/
#include "acconv.h"
#include "file_sel.h"
#include "xfile.h"
#include "stringuty.h"
#include "luty.h"

#include "bitmaps/floppy.xbm"	
#include "bitmaps/floppy_m.xbm"	

typedef enum {NO_READ, READ_OK, WRITE_OK} FileAccess;

Widget topLevel;

Atom AcTreeAtom;

void partsAdd(Widget w, XtPointer client_data, XtPointer call_data);
void partsDelete(Widget w, XtPointer client_data, XtPointer call_data);
void partsDeleteInMenu(Widget w, XtPointer client_data, XtPointer call_data);
void partsRefresh(Widget w, XtPointer client_data, XtPointer call_data);
extern PartsTree *CurrentParts;
Widget mguiList;
Widget mguiTree;
Widget filenamewindow;
Pixmap mark, /* mark64, */ diskMark, diskDisable;
Widget mguiSourceShell, mguiSourceArea, mguiSourceTools;
Widget mguiPopdown, mguiSave, mguiLoad, mguiSourceFile, mguiSourceSelect, mguiSourceText;
Widget mguiRename;

char *HomeDirectory;
char *localeName = NULL;

char Filepath[4096];

void widgetInit(void);
void preFileMenu(Widget w, XtPointer client_data, XtPointer garbage);
void preCommandMenu(Widget w, XtPointer client_data, XtPointer garbage);
void load_chd(Widget w, XtPointer client_data, XtPointer call_data);
void save_chd(Widget w, XtPointer client_data, XtPointer call_data);
void quit(Widget w, XtPointer client_data, XtPointer call_data);
void partsTreeSave(PartsTree *parts, FILE *fp);
void makeSource(Widget w, XtPointer client_data, XtPointer call_data);

extern FileSelctorInfo fileSelecterInfo;
extern MessageNode *FallbackDict;	/* ǥեȡå */

AppData app_data;

/* resource list */
static XtResource resources[] = {
	{
		XtNmessages,
		XtCMessages,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, messages),
		XtRImmediate,
		(XtPointer) NULL
	}, 
	{
		XtNhelp,
		XtCHelp,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, help),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNjencoding,
		XtCJencoding,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, jencoding),
		XtRImmediate,
		(XtPointer) ENCODING_DIR,
	},
};

/* Command-line options table */
static XrmOptionDescRec options[] = {
	{"-h", 			"*help", 				XrmoptionNoArg, "True"},
	{"--help", 		"*help", 				XrmoptionNoArg, "True"},
};

/***************************************************************************
 *	TopMenuPanes: ե롦˥塼ѹ¤̻
 *		
 *	
 *		󷿤μ̻			˥塼̾			
 *	
 *		TopLineFilePane			--------				˥塼ʬ
 *	
 *		LoadFilePane			Load					ɤ߹
 *	
 *		SaveFilePane			Save					¸
 *	
 *		ClearAll				Clear All				
 *	
 *		MenuLine1FilePane		--------				˥塼ʬ
 *	
 *		MakeSourceFilePane		Make Source File		ɺ
 *	
 *		MakeResourceFilePane	Make Resource File		꥽ե
 *	
 *		MenuLine2FilePane		--------				˥塼ʬ
 *	
 *		QuitFilePane			Quit					λ
 *	
 *		
 ***************************************************************************/
enum _TopMenuPanes {
	TopLineFilePane = 0, LoadFilePane, SaveFilePane, ClearAll, MenuLine1FilePane, 
	MakeSourceFilePane, MakeResourceFilePane, MenuLine2FilePane, QuitFilePane
} TopMenuPanes;

/***************************************************************************
 *	topMenuInfo: ե롦˥塼
 *	
 *		ե˥塼ѡ¤
 *	
 *	
 *		ʤξ		å̾			
 *	
 *		ե롦		fileTopLine				˥塼ʬ
 *			˥塼	topMenuInfo[0]
 *	
 *		ե롦		fileLoad				ɤ߹ߡ
 *			˥塼	topMenuInfo[1]			load_chd()
 *	
 *		ե롦		fileSave				¸
 *			˥塼	topMenuInfo[2]			save_chd()
 *	
 *		ե롦		fileClear				
 *			˥塼	topMenuInfo[3]			partsClearAll()
 *	
 *		ե롦		fileMenuLine1			˥塼ʬ
 *			˥塼	topMenuInfo[4]
 *	
 *		ե롦		fileMakeSource			ɺ
 *			˥塼	topMenuInfo[5]			makeSource()
 *	
 *		ե롦		fileMakeResource		꥽ե롾
 *			˥塼	topMenuInfo[6]			makeResourceManager()
 *	
 *		ե롦		fileTopLine				˥塼ʬ
 *			˥塼	topMenuInfo[7]
 *	
 *		ե롦		fileLoad				λ
 *			˥塼	topMenuInfo[8]			quit()
 *	
 *	
 *		
 ***************************************************************************/
struct menu_data topMenuInfo[] = {
	{TypeSmeLine, "fileTopLine", 		NULL, NULL, 			NULL},
	{TypeSmeBSB,  "fileLoad", 			NULL, load_chd, 		NULL}, 
	{TypeSmeBSB,  "fileSave", 			NULL, save_chd, 		NULL},
	{TypeSmeBSB,  "fileClear", 			NULL, partsClearAll, 	&CurrentParts}, 
	{TypeSmeLine, "fileMenuLine1", 		NULL, NULL, 			NULL},
	{TypeSmeBSB,  "fileMakeSource", 	NULL, makeSource, 		&CurrentParts},
	{TypeSmeBSB,  "fileMakeResource", 	NULL, makeResourceManager, 	NULL},
	{TypeSmeLine, "fileMenuLine2", 		NULL, NULL, 			NULL},
	{TypeSmeBSB,  "fileQuit", 			NULL, quit, 			NULL},
	{EOF, NULL, NULL, NULL, NULL}
};

/***************************************************************************
 *	
 *	
 *	
 *		С					Ư				
 *	
 *		applicationMenu.menuButton	˥塼ܥ		makeMenus() 
 *									Υå		
 *	
 *		applicationMenu.menu		˥塼			makeMenus() 
 *									å		
 *	
 *		applicationMenu.menuName	˥塼δ̾	˻
 *	
 *		applicationMenu.num			˥塼ܤο	
 *	
 *		applicationMenu.popup()		ݥåץå״ؿ	
 *	
 *		applicationMenu.popdown		ݥåץؿ	
 *	
 *		applicationMenu.info		˥塼ܾ	
 *	
 *		
 *		makeMenus() ǥ˥塼뤿ξ
 *		
 ***************************************************************************/
struct menuData applicationMenu = {
	NULL,
	NULL,
	"fileMenu", 
	sizeof(topMenuInfo) / sizeof(topMenuInfo[0]) - 1,
	preFileMenu, 
	NULL, 
	topMenuInfo
};

/***************************************************************************
 *	cmdMenuInfo: ޥɡ˥塼
 *	
 *		ޥɥ˥塼ѡ¤
 *	
 *	
 *		ʤξ		å̾			
 *	
 *		ޥɡ		cmdMenuTopLine			˥塼ʬ
 *			˥塼	cmdMenuInfo[0]
 *	
 *		ޥɡ		cmdAdd					ɲá̤
 *			˥塼	cmdMenuInfo[1]			
 *	
 *		ޥɡ		cmdDel					ʺ̤
 *			˥塼	cmdMenuInfo[2]			partsDeleteInMenu()
 *	
 *		ޥɡ		cmdRefresh				ʺƹ
 *			˥塼	cmdMenuInfo[2]			partsRefresh()
 *	
 *		ޥɡ		cmdMenuLine1			˥塼ʬ
 *			˥塼	cmdMenuInfo[3]			
 *	
 *		ޥɡ		cmdCut					ʤΥåȡ̤
 *			˥塼	cmdMenuInfo[4]			
 *	
 *		ޥɡ		cmdCopy					ʤΥԡ̤
 *			˥塼	cmdMenuInfo[5]			
 *	
 *		ޥɡ		cmdPaste				ʤΥڡȡ̤
 *			˥塼	cmdMenuInfo[6]			
 *	
 *		ޥɡ		cmdMenuLine1			˥塼ʬ
 *			˥塼	cmdMenuInfo[7]
 *	
 *		ޥɡ		cmdMap					ƥʤΥޥå
 *			˥塼	cmdMenuInfo[8]			partsMap()
 *	
 *		ޥɡ		cmdUnmap				ƥʤΥޥå
 *			˥塼	cmdMenuInfo[9]			partsUnmap()
 *	
 *		ޥɡ		cmdAutoMap				ȥޥå
 *			˥塼	cmdMenuInfo[10]			partsMapAuto()
 *	
 *		ޥɡ		cmdMenuLine2			˥塼ʬ
 *			˥塼	cmdMenuInfo[11]			
 *	
 *		ޥɡ		cmdPopup				ƥʤΥݥåץå
 *			˥塼	cmdMenuInfo[12]			partsPopup()
 *	
 *		ޥɡ		cmdPopdown				ƥʤΥݥåץ
 *			˥塼	cmdMenuInfo[13]			partsPopdown()
 *	
 *		ޥɡ		cmdMenuLine3			˥塼ʬ
 *			˥塼	cmdMenuInfo[14]			
 *	
 *		ޥɡ		cmdWidgetName			ĥ꡼ʤ
 *			˥塼	cmdMenuInfo[15]			å̾ɽ
 *	
 *		ޥɡ		cmdClassName			ĥ꡼ʤ
 *			˥塼	cmdMenuInfo[16]			饹̾ɽ
 *	
 *		ޥɡ		cmdVariable				ĥ꡼ʤ
 *			˥塼	cmdMenuInfo[17]			åѿ̾ɽ
 *	
 *		ޥɡ		cmdWidgetClass			ĥ꡼ʤΥå
 *			˥塼	cmdMenuInfo[18]			̾饹̾ɽ
 *	
 *		ޥɡ		cmdMenuLine4			˥塼ʬ
 *			˥塼	cmdMenuInfo[19]			
 *	
 *		ޥɡ		cmdSetResource			꥽Խ
 *			˥塼	cmdMenuInfo[20]
 *	
 *	
 *		
 ***************************************************************************/
struct menu_data cmdMenuInfo[] = {
	{TypeSmeLine, "cmdMenuTopLine", NULL, NULL, NULL},
	{TypeSmeBSB,  "cmdAdd", 		NULL, NULL, NULL}, 
	{TypeSmeBSB,  "cmdDel", 		NULL, partsDeleteInMenu, &CurrentParts}, 
	{TypeSmeBSB,  "cmdRefresh", 	NULL, partsRefresh, &CurrentParts}, 
	{TypeSmeLine, "cmdMenuLine1", 	NULL, NULL, NULL},
	{TypeSmeBSB,  "cmdCut", 		NULL, NULL, NULL}, 
	{TypeSmeBSB,  "cmdCopy", 		NULL, NULL, NULL}, 
	{TypeSmeBSB,  "cmdPaste", 		NULL, NULL, NULL}, 
	{TypeSmeLine, "cmdMenuLine1", 	NULL, NULL, NULL},
	{TypeSmeBSB,  "cmdMap", 		NULL, partsMap, 	&CurrentParts}, 
	{TypeSmeBSB,  "cmdUnmap", 		NULL, partsUnmap, 	&CurrentParts}, 
	{TypeSmeBSB,  "cmdAutoMap", 	NULL, partsMapAuto, &CurrentParts},
	{TypeSmeLine, "cmdMenuLine2", 	NULL, NULL, NULL},
	{TypeSmeBSB,  "cmdPopup", 		NULL, partsPopup, 	&CurrentParts}, 
	{TypeSmeBSB,  "cmdPopdown",		NULL, partsPopdown, &CurrentParts}, 
	{TypeSmeLine, "cmdMenuLine3", 	NULL, NULL, NULL},
	{TypeSmeBSB,  "cmdWidgetName",	NULL, partsWidgetName, 	&CurrentParts}, 
	{TypeSmeBSB,  "cmdClassName", 	NULL, partsClassNames, 	&CurrentParts}, 
	{TypeSmeBSB,  "cmdVariable", 	NULL, partsWidgetVariable, 	&CurrentParts}, 
	{TypeSmeBSB,  "cmdWidgetClass", NULL, partsWidgetAndClassNames, &CurrentParts}, 
	{TypeSmeLine, "cmdMenuLine4", 	NULL, NULL, NULL},
	{TypeSmeBSB,  "cmdSetResource", NULL, partsResourceBox, &CurrentParts},
	{EOF, NULL, NULL, NULL, NULL}
};

/***************************************************************************
 *	
 *	
 *	
 *		С					Ư				
 *	
 *		commandMenu.menuButton		˥塼ܥ		makeMenus() 
 *									Υå		
 *	
 *		commandMenu.menu			˥塼			makeMenus() 
 *									å		
 *	
 *		commandMenu.menuName		˥塼δ̾	˻
 *	
 *		commandMenu.num				˥塼ܤο	
 *	
 *		commandMenu.popup()			ݥåץå״ؿ	
 *	
 *		commandMenu.popdown			ݥåץؿ	
 *	
 *		commandMenu.info			˥塼ܾ	
 *	
 *		
 *		makeMenus() ǥ˥塼뤿ξ
 *		
 ***************************************************************************/
struct menuData commandMenu = {
	NULL,
	NULL,
	"commandMenu", 
	sizeof(cmdMenuInfo) / sizeof(cmdMenuInfo[0]) - 1,
	preCommandMenu, 
	NULL, 
	cmdMenuInfo
};

void loadSelectFinish(const char *dirName, const char *fileName);
void saveSelectFinish(const char *dirName, const char *fileName);

fSelectorMenuInfo loadSelectorInfomation = {
	&filePickupPaneInfo[3], &fileSortPaneInfo[1], loadSelectFinish
};
fSelectorMenuInfo saveSelectorInfomation = {
	&filePickupPaneInfo[3], &fileSortPaneInfo[1], saveSelectFinish
};

/***************************************************************************
 *	load_chd: 
 *	
 *		void load_chd(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ե롦		fileLoad				ɤ߹ߡ
 *			˥塼	topMenuInfo[1]			load_chd()
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
void load_chd(Widget w, XtPointer client_data, XtPointer call_data)
{
	/*chdir(fileSelecterInfo.searchingPath);*/
	fileSelecterInfo.searchingPath = Filepath;
	chdir(fileSelecterInfo.searchingPath);
}

/***************************************************************************
 *	save_chd: 
 *	
 *		void save_chd(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ե롦		fileSave				¸
 *			˥塼	topMenuInfo[2]			save_chd()
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
void save_chd(Widget w, XtPointer client_data, XtPointer call_data)
{
	fileSelecterInfo.searchingPath = Filepath;
	chdir(fileSelecterInfo.searchingPath);
}

/***************************************************************************
 *	preFileMenu: ե롦˥塼ġԲɽ
 *	
 *		static void preFileMenu(Widget w, 
 *								XtPointer client_data, XtPointer garbage);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	˥塼ֹ
 *		XtPointer garbage;		̤
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
void preFileMenu(Widget w, XtPointer client_data, XtPointer garbage)
{
	Boolean sensitive;
	struct menuData *menuInfo = (struct menuData*) client_data;

	sensitive = (CurrentParts != NULL);
	XtSetSensitive((menuInfo->info+SaveFilePane)->myWidget, sensitive);
	XtSetSensitive((menuInfo->info+MakeSourceFilePane)->myWidget, sensitive);
}

/***************************************************************************
 *	preFileMenu: ե롦˥塼ġԲɽ
 *	
 *		static void preFileMenu(Widget w, 
 *								XtPointer client_data, XtPointer garbage);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	˥塼ֹ
 *		XtPointer garbage;		̤
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */

void preCommandMenu(Widget w, XtPointer client_data, XtPointer garbage)
{
	int counter;
	Boolean sensitive;
	struct menuData *menuInfo = (struct menuData*) client_data;
	struct menu_data *menuPanes = menuInfo->info;

	sensitive = (CurrentParts != NULL);
	for(counter = 0;counter < menuInfo->num;++counter) {
		switch((menuPanes+counter)->type) {
		case TypeSmeBSB:
			sensitive = ((menuInfo->info+counter)->function != NULL);
			XtSetSensitive((menuInfo->info+counter)->myWidget, sensitive);
			break;
		default:
			break;
		}
	}
}

/***************************************************************************
 *	loadSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void loadSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void loadSelectFinish(const char *dirName, const char *fileName)
{
	FILE *fp;
	/*extern Widget filenamewindow;*/

	sprintf(Filepath, "%s/%s", dirName, fileName);
	/*XtVaSetValues(filenamewindow, XtNstring, XtNewString(filepath), NULL);*/

	if((fp = fopen(Filepath, "r")) != NULL) {
		partsTreeLoad(&CurrentParts, fp);
		fclose(fp);
	}
}

/***************************************************************************
 *	saveSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void saveSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void saveSelectFinish(const char *dirName, const char *fileName)
{
	FILE *fp;

	sprintf(Filepath, "%s/%s", dirName, fileName);

	if((fp = fopen(Filepath, "w")) != NULL) {
		partsTreeSave(CurrentParts, fp);
		fclose(fp);
	}
}

/***************************************************************************
 *	PannerCallback: panner åȤΥХåؿ
 *	
 *		void PannerCallback(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				panner å
 *		XtPointer client_data;	Porthole λҥå
 *		XtPointer call_data;	the panner record.
 *	
 *		
 *		XtNreportCallback
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ѥͥ			mguiPanner			ľܤΥХå
 *	
 *		
 *		
 ***************************************************************************/
void PannerCallback(Widget w, XtPointer client_data, XtPointer call_data)
{
    Widget tree_widget = (Widget)client_data;
    XawPannerReport *report = (XawPannerReport*)call_data;

    XtVaSetValues(tree_widget, 
						XtNx, -report->slider_x, 
						XtNy, -report->slider_y, NULL);
}

/***************************************************************************
 *	PortholeCallback: Porthole åȤΥХåؿ
 *	
 *		void PortholeCallback(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				porthole å
 *		XtPointer client_data;	panner å
 *		XtPointer call_data;	the porthole record.
 *	
 *		called when the porthole or its child has changed 
 *		
 *		XtNreportCallback
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ᥤ󡦥ꥢ	mguiTreeArea			ľܤΥХå
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
void PortholeCallback(Widget w, XtPointer client_data, XtPointer call_data)
{
    XawPannerReport *report = (XawPannerReport *) call_data;
    Widget panner = (Widget) client_data;

    XtVaSetValues(panner, 
					XtNsliderX, report->slider_x,
					XtNsliderY, report->slider_y, NULL);
    if (report->changed != (XawPRSliderX | XawPRSliderY)) {
    	XtVaSetValues(panner,
    				XtNsliderWidth, report->slider_width, 
    				XtNsliderHeight, report->slider_height, 
    				XtNcanvasWidth, report->canvas_width, 
    				XtNcanvasHeight, report->canvas_height, NULL);
    }
}

/***************************************************************************
 *	namingDialogInit: å̾ϿѤΥޤॷ
 *	
 *		Widget namingDialogInit(Widget parent);
 *	
 *		Widget parent;		ƥå
 *	
 *		
 ***************************************************************************/
Widget namingDialogInit(Widget parent)
{
	Widget enterShell;
	Widget namingDialog;

	enterShell = XtCreatePopupShell(
			"enterShell",
			transientShellWidgetClass,
			parent,
			NULL,
			0
			);

	namingDialog = XtCreateManagedWidget(
			"namingDialog",				/* widget name   */
			dialogWidgetClass,			/* widget class */
			enterShell,				/* parent widget*/
			NULL,						/* argument list*/
			0							/* arglist size */
			);

	XawDialogAddButton(namingDialog, "namingDialogSet",
							NamingDialogSet, namingDialog);

	XawDialogAddButton(namingDialog, "namingDialogPopdown",
							NamingDialogPopdown, namingDialog);

	return(namingDialog);
}

FileAccess CheckFilePermissions(char *file, Boolean * exists);

/***************************************************************************
 *	MaybeCreateFile: 
 *	
 *		FileAccess MaybeCreateFile(char *file);
 *	
 *		char *file;
 *	֤
 *		եΥ
 *	
 *		
 ***************************************************************************/
FileAccess MaybeCreateFile(char *file)
{
	Boolean exists;
	int fd;

	if (access(file, F_OK) != 0) {
		fd = creat(file, 0666);
		if (fd != -1)
			close(fd);
	}
	return (CheckFilePermissions(file, &exists));
}

/***************************************************************************
 *	srcSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void srcSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void srcSelectFinish(const char *dirName, const char *fileName)
{
	char filepath[4096];

	sprintf(filepath, "%s/%s", dirName, fileName);
#ifndef	NO_XAW_BUG
	XtVaSetValues(mguiSourceFile, XtNstring, XtNewString(filepath), NULL);
#else
	XtVaSetValues(mguiSourceFile, XtNstring, filepath, NULL);
#endif	/*XAW_BUG*/
}

/***************************************************************************
 *	srcFileSelector: ե롦쥯ƤӽФ
 *	
 *		void srcFileSelector(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void srcFileSelector(Widget w, XtPointer client_data, XtPointer call_data)
{
	char dirName[4096];
	char fileName[1024];
	String filepath;
	extern selectorPanes filePickupPaneInfo[];
	extern selectorPanes fileSortPaneInfo[];
	static selectorPanes *defPickup = &filePickupPaneInfo[1];
	static selectorPanes *defSort = &fileSortPaneInfo[1];

	XtVaGetValues(mguiSourceFile, XtNstring, &filepath, NULL);
	dirName[0] = '\0';
	fileName[0] = '\0';
	fileCheck(filepath, sizeof(dirName), dirName, sizeof(fileName), fileName);
	fileSelectorCall(w, dirName, defPickup, defSort, srcSelectFinish);
}

/***************************************************************************
 *	CheckFilePermissions: 
 *	
 *		FileAccess CheckFilePermissions(char *file, Boolean *exists);
 *	
 *		char *file;
 *		Boolean *exists;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
FileAccess CheckFilePermissions(char *file, Boolean * exists)
{
	char temp[BUFSIZ], *ptr;

	if (access(file, F_OK) == 0) {
		*exists = TRUE;

		if (access(file, R_OK) != 0)
			return (NO_READ);

		if (access(file, R_OK | W_OK) == 0)
			return (WRITE_OK);
		return (READ_OK);
	}
	*exists = FALSE;

	strcpy(temp, file);
	if ((ptr = rindex(temp, '/')) == NULL)
		strcpy(temp, ".");
	else
		*ptr = '\0';

	if (access(temp, R_OK | W_OK | X_OK) == 0)
		return (WRITE_OK);
	return (NO_READ);
}

void saveSourceFile(Widget w, XtPointer client_data, XtPointer call_data)
{
	String filename;
	char buf[BUFSIZ];
	const char *buttonMessages[] = {"OK", NULL};
	const char *buttonMessageArray[2];

	buttonMessageArray[0] = keyword2mes(buttonMessages[0]);
	buttonMessageArray[1] = NULL;
	XtVaGetValues(mguiSourceFile, XtNstring, &filename, NULL);

	if( (filename == NULL) || (strlen(filename) == 0) ){
		messengerPrintf(w, NULL, NULL, NULL, 
					buttonMessageArray, keyword2mes("NOFILLE"));
		return;
	}
#ifdef	NEXT_IMPLEMENT
	if (app_resources.enableBackups) {
		char backup_file[BUFSIZ];
		makeBackupName(backup_file, filename);

		if (rename(filename, backup_file) != 0) {
			messengerPrintf(w, NULL, NULL, NULL, buttonMessageArray, 
					  "error backing up file:  %s\n",  backup_file); 
		}
	}
#endif	/*NEXT_IMPLEMENT*/

	switch(MaybeCreateFile(filename)) {
	case NO_READ:
	case READ_OK:
		messengerPrintf(w, NULL, NULL, NULL, buttonMessageArray, 
					keyword2mes("COULDNTOPEN"), filename);
		break;
	case WRITE_OK:
		if(XawAsciiSaveAsFile(XawTextGetSource(mguiSourceText), filename) ) {
			messengerPrintf(w, NULL, NULL, NULL, buttonMessageArray, 
					keyword2mes("SAVED"), filename);
			/* ResetSourceChanged(mguiSourceText); */
		} else {
			messengerPrintf(w, NULL, NULL, NULL, buttonMessageArray, 
					keyword2mes("SAVEERROR"),  filename);
		}
		break;
	default:
		messengerPrintf(w, NULL, NULL, NULL, 
						buttonMessageArray, keyword2mes("SAVEBUG"));
	}
}

/***************************************************************************
 *	LabelPixmaps: ٥ѤΥԥޥåפޤ
 *	
 *		void LabelPixmaps(Display *display, Drawable drawable);
 *	
 *		Display *display;
 *		Drawable drawable;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void LabelPixmaps(Display *display, Drawable drawable)
{
	diskMark = XCreateBitmapFromData(display, drawable, 
			floppy_bits, floppy_width, floppy_height);

	diskDisable = XCreateBitmapFromData(display, drawable, 
			floppy_m_bits, floppy_m_width, floppy_m_height);

	mark = XCreateBitmapFromData(XtDisplay(topLevel), 
						RootWindowOfScreen(XtScreen(topLevel)), 
						xlogo11_bits, xlogo11_width, xlogo11_height);

#ifdef xlogo64_width
	mark64 = XCreateBitmapFromData(XtDisplay(topLevel), 
						RootWindowOfScreen(XtScreen(topLevel)), 
						xlogo64_bits, xlogo64_width, xlogo64_height);
#endif /*xlogo64_width*/
}

/***************************************************************************
 *	quit: acconv λ
 *	
 *		void quit(void);
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
void quit(Widget w, XtPointer client_data, XtPointer call_data)
{
	exit(0);
}

/***************************************************************************
 *	main: acconv Υᥤؿ
 *	
 *		int main(int argc, char **argv);
 *	
 *		int argc;		ޥɥ饤ο
 *		char **argv;	ޥɥ饤ʸΥݥ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int main(int argc, char **argv)
{
	char title[256];
	XtAppContext app_context;
	Widget mguiShell, mguiArea, mguiMenuArea;
	Widget mguiPanel, mguiPanner, mguiView;
	Widget mguiTool, mguiAdd, mguiDel, mguiCut, mguiPaste;
	Widget mguiLogo, mguiTreeArea;
	Widget dialog;
	Widget fileSelect;

	XtSetLanguageProc(NULL, NULL, NULL);

	topLevel = XtVaAppInitialize(
		&app_context, 				/* Application context */
		"Acconv", 					/* Application class */
		options, XtNumber(options), /* command line */
		&argc, argv,				/* command line args */
		NULL, 						/* for missing app-defaults file */
		NULL);						/* terminate varargs list */

	XtGetApplicationResources(topLevel, 
		&app_data, 
		resources, 
		XtNumber(resources), 
		NULL, 
		0);

	HomeDirectory = getenv("HOME");

	LabelPixmaps(XtDisplay(topLevel), RootWindowOfScreen(XtScreen(topLevel)));

	FallbackDict = makeMessages(NULL, app_data.messages);

	mguiShell = XtVaCreatePopupShell(
		"mguiShell", 
		topLevelShellWidgetClass,	/* widget class */
		topLevel, 
		NULL);

	mguiArea = XtVaCreateManagedWidget(
		"mguiArea", 				/* arbitrary widget name */
		panedWidgetClass,			/* widget class from Form.h */
		mguiShell,	 				/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiMenuArea = XtVaCreateManagedWidget(
		"mguiMenuArea", 			/* arbitrary widget name */
		boxWidgetClass,				/* widget class from Form.h */
		mguiArea,	 				/* parent widget */
		NULL);						/* tarminate varargs list */

	makeMenus(mguiMenuArea, &applicationMenu);
	fileDialogInit(applicationMenu.menu);
	XtAddCallback(topMenuInfo[1].myWidget, 
					XtNcallback, fileSelector, &loadSelectorInfomation);
	XtAddCallback(topMenuInfo[2].myWidget, 
					XtNcallback, fileSelector, &saveSelectorInfomation);
	makeMenus(mguiMenuArea, &commandMenu);

	mguiSourceShell = XtVaCreateManagedWidget(
		"mguiSourceShell", 			/* arbitrary widget name */
		transientShellWidgetClass,	/* widget class from Form.h */
		topLevel,  					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiSourceArea = XtVaCreateManagedWidget(
		"mguiSourceArea", 			/* arbitrary widget name */
		panedWidgetClass,			/* widget class from Form.h */
		mguiSourceShell,	 		/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiSourceTools = XtVaCreateManagedWidget(
		"mguiSourceTools", 			/* arbitrary widget name */
		panedWidgetClass,			/* widget class from Form.h */
		mguiSourceArea,	 			/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiPopdown = XtVaCreateManagedWidget(
		"mguiPopdown", 				/* arbitrary widget name */
		commandWidgetClass,			/* widget class from Form.h */
		mguiSourceTools,	 		/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiSave = XtVaCreateManagedWidget(
		"mguiSave", 				/* arbitrary widget name */
		commandWidgetClass,			/* widget class from Form.h */
		mguiSourceTools,	 		/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiLoad = XtVaCreateManagedWidget(
		"mguiLoad", 				/* arbitrary widget name */
		commandWidgetClass,			/* widget class from Form.h */
		mguiSourceTools,	 		/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiSourceFile = XtVaCreateManagedWidget(
		"mguiSourceFile", 			/* arbitrary widget name */
		asciiTextWidgetClass,		/* widget class from Form.h */
		mguiSourceTools,	 		/* parent widget */
		XtNeditType, XawtextEdit, 
		NULL);						/* tarminate varargs list */

	mguiSourceSelect = XtVaCreateManagedWidget(
		"mguiSourceSelect", 		/* widget name */
		commandWidgetClass, 		/* widget class */
		mguiSourceTools, 			/* parent widget */
		XtNbitmap, diskMark,		/* argument list */
		NULL);						/* tarminate varargs list */

	mguiSourceText = XtVaCreateManagedWidget(
		"mguiSourceText", 			/* arbitrary widget name */
		asciiTextWidgetClass,		/* widget class from Form.h */
		mguiSourceArea,	 			/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiPanel = XtVaCreateManagedWidget(
		"mguiPanel", 				/* arbitrary widget name */
		panedWidgetClass,			/* widget class from Form.h */
		mguiArea,	 				/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiPanner = XtVaCreateManagedWidget(
		"mguiPanner", 				/* arbitrary widget name */
		pannerWidgetClass,			/* widget class from Form.h */
		mguiPanel,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiView = XtVaCreateManagedWidget(
		"mguiView", 				/* arbitrary widget name */
		viewportWidgetClass,		/* widget class from Form.h */
		mguiPanel,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiList = XtVaCreateManagedWidget(
		"mguiList", 				/* arbitrary widget name */
		listWidgetClass,			/* widget class from Form.h */
		mguiView,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiTool = XtVaCreateManagedWidget(
		"mguiTool", 				/* arbitrary widget name */
		panedWidgetClass,			/* widget class from Form.h */
		mguiPanel,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiAdd = XtVaCreateManagedWidget(
		"mguiAdd", 				/* arbitrary widget name */
		commandWidgetClass,			/* widget class from Form.h */
		mguiTool,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiDel = XtVaCreateManagedWidget(
		"mguiDel", 				/* arbitrary widget name */
		commandWidgetClass,			/* widget class from Form.h */
		mguiTool,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiCut = XtVaCreateManagedWidget(
		"mguiCut", 					/* arbitrary widget name */
		commandWidgetClass,			/* widget class from Form.h */
		mguiTool,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiPaste = XtVaCreateManagedWidget(
		"mguiPaste", 				/* arbitrary widget name */
		commandWidgetClass,			/* widget class from Form.h */
		mguiTool,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiRename = XtVaCreateManagedWidget(
		"mguiRename", 				/* arbitrary widget name */
		commandWidgetClass,			/* widget class from Form.h */
		mguiTool,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiLogo = XtVaCreateManagedWidget(
		"mguiLogo", 				/* arbitrary widget name */
		labelWidgetClass,			/* widget class from Form.h */
		mguiPanel,					/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiTreeArea = XtVaCreateManagedWidget(
		"mguiTreeArea", 			/* arbitrary widget name */
		portholeWidgetClass,		/* widget class from Form.h */
		mguiArea,	 				/* parent widget */
		NULL);						/* tarminate varargs list */

	mguiTree = XtVaCreateManagedWidget(
		"mguiTree", 				/* arbitrary widget name */
		treeWidgetClass,			/* widget class from Form.h */
		mguiTreeArea,	 			/* parent widget */
		NULL);						/* tarminate varargs list */

	createResourceFile(topLevel);

	widgetInit();		/* widgetSet μֹ(ID) */
	
	dialog = namingDialogInit(mguiAdd);
	makableObject(CurrentParts);
	XtAddCallback(mguiAdd, XtNcallback, PopupNamingDialog, dialog);
	XtAddCallback(mguiDel, XtNcallback, partsDelete, &CurrentParts);
	XtAddCallback(mguiRename, XtNcallback, setNames, &CurrentParts);
	XtAddCallback(mguiRename, XtNcallback, 
				XtCallbackExclusive, createRenameShell(mguiRename));
	XtAddCallback(cmdMenuInfo[1].myWidget, 
							XtNcallback, PopupNamingDialog, dialog);

	XtAddCallback(mguiPanner, XtNreportCallback, PannerCallback, mguiTree);
	XtAddCallback(mguiTreeArea, XtNreportCallback, PortholeCallback, mguiPanner);
	XtAddCallback(mguiSave, XtNcallback, saveSourceFile, NULL);
	XtAddCallback(mguiSourceSelect, XtNcallback, srcFileSelector, NULL);
	XtAddCallback(mguiPopdown, XtNcallback, PopdownAncestorShell, NULL);

	getcwd(Filepath, sizeof(Filepath));

	jaEncodeType();
	localeName = setlocale(LC_CTYPE, NULL);
	sprintf(title, "Acconv Version 0.1.2 -- [%s]", setlocale(LC_CTYPE, NULL));
	XtVaSetValues(mguiShell, XtNtitle, title, NULL);

	AcTreeAtom = XInternAtom(XtDisplay(topLevel), 
						ACCONV_TREE_PROPERTY_NAME, FALSE);

	XtRealizeWidget(mguiShell);
	XtMapWidget(mguiShell);

	XtAppMainLoop(app_context);
	return(0);
}

