/****************************************************************************
 *	acconv: Athena Widget -> Code Conveterter
 *			~                ~    ~~~~
 *			Date. 1995/11/18 -- 1996/01/06
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

#ifndef	ATHENA_PREVIEWER
#define	ATHENA_PREVIEWER

/*************************************
 *	X Toolkit Υ󥯥롼ɥե
 *************************************/
#include <X11/Intrinsic.h>		/* Intrinsics Definitions */
#include <X11/StringDefs.h>		/* Standard Name-String definitions */

#define NoChild		(0)
#define OneChild	(1)
#define MultiChild	(EOF)

struct _AWidgetInfo;

#define NoWidget		-1
#define MetaClass		0x8000
#define NormalWidget	0x0001
#define ShellWidget 	0x0010
#define SimpleMenu		0x0030
#define SmeObject 		0x0100

#define ACCONV_TREE_PROPERTY_NAME	"ACCONV_TREE"

/***************************************************************************
 *	PartsTree ʥĥ꡼¤
 *	Сѿ
 *		widgetName:		å̾
 *		variableName:	åȤѿ̾
 *		className:		饹̾ʥ饹ݥ̾
 *		partsWidget:	ƥȼ¸ѤΥå
 *		treeWidget:		ĥ꡼ɽѤΥå
 *		mapping:		ƥŪʥޥåԥ󥰤ԤäƤ?
 *		athenaInfo:		ʼAWidgetInfo
 *		parent_ptr:		ʹĥ꡼ǿƤؤݥ
 *		child_ptr:		ʹĥ꡼ǻҤؤݥ
 *		prev_ptr:		ʹĥ꡼ǷƱƤľˤؤݥ
 *		next_ptr:		ʹĥ꡼ƱƤľˤؤݥ
 *	ǡ¤
 *		ʹĥ꡼κܨʨ
 *		
 *		 widgetName ʸ󨭡 widgetName ʸ
 *		
 *		variableNameʸ󨭡variableNameʸ
 *		
 *		  className ʸ󨭡  className ʸ
 *		
 *		 partsWidget partsWidget
 *		
 *		 treeWidget  treeWidget 
 *		
 *		mapping mapping 
 *		
 *		 athenaInfo  athenaInfo 
 *		
 *		 parent_ptr  NULL  parent_ptr 
 *		
 *		 child_ptr child_ptr   NULL 
 *		
 *		prev_ptr NULL prev_ptr NULL 
 *		
 *		next_ptr NULL next_ptr
 *		
 *		
 *		
 *		ʨ
 *		
 *		 widgetName ʸ
 *		
 *		variableNameʸ
 *		
 *		 className  ʸ
 *		
 *		 partsWidget
 *		
 *		 treeWidget 
 *		
 *		mapping 
 *		
 *		 athenaInfo 
 *		
 *		 parent_ptr 
 *		
 *		 child_ptr   NULL 
 *		
 *		prev_ptr
 *		ʹĥ꡼
 *		next_ptr NULL 
 *		
 *		
 *		
 *		
 *		
 *		ʼ̾󡡨
 *		
 *		
 *		
 *		
 *		 publicInclude  
 *		 publicInclude  
 *		 className   publicInclude  
 *		 className  
 *		  variableName   className  
 *		  variableName  
 *		   partsClass     variableName  
 *		   partsClass   
 *	
 ***************************************************************************/
typedef struct _PartsTree {
	char *widgetName;
	char *variableName;
	char *className;
	Widget partsWidget;
	Widget treeWidget;
	int mapping;
	struct _AWidgetInfo *athenaInfo;
	struct _PartsTree *parent_ptr;
	struct _PartsTree *child_ptr;
	struct _PartsTree *prev_ptr;
	struct _PartsTree *next_ptr;
} PartsTree;

/***************************************************************************
 *	AWidgetInfo ʼ
 *	Сѿ
 *		publicInclude:	ѥ֥å󥯥롼ɡեʸ
 *		className:		饹̾ʸ
 *		variableName:	ѿ̾ʥ饹ݥ󥿡ˡʸ
 *		partsClass:		饹ݥ
 *		instance:		󥹥󥹲եޥåʸ
 *		argTypes:		
 *		childExist:		ҥåȤμ¸
 *		type:			ʼ
 *		remakable:		ƹǽȽؿ
 *		creatable:		ĥ꡼¤ǽȽؿ
 *		realizable:		ƥʼ¸ǽȽؿ
 *		widgetCreation:	ʺؿ
 *		id:				̤
 *	ǡ¤
 *		
 *		
 *		 publicInclude  ʸ󡡡
 *		
 *		 className  ʸ󡡡
 *		
 *		  variableName  ʸ󡡡
 *		
 *		   partsClass   饹ݥ󥿨
 *		󥹥󥹲
 *		    instance    եޥåʸ
 *		
 *		    argTypes    󨬨
 *		   ArgWidget  
 *		   childExist   
 *		ArgWidgetName 
 *		      type      
 *		ArgWidgetClass
 *		   remakable()  ؿؤΥݥ󥿨
 *		   ArgParent  
 *		   creatable()  ؿؤΥݥ󥿨
 *		     NoArg    
 *		  realizable()  ؿؤΥݥ󥿨
 *		
 *		widgetCreation()ؿؤΥݥ󥿨
 *		
 *		 id 
 *		
 *		
 *	
 *		AWidgetInfo widgetSet[] = {
 *			{
 *				"#include <X11/Composite.h>", 	
 *				"Composite", 					
 *				"compositeWidgetClass",			
 *				&compositeWidgetClass,			
 *				NULL, 							
 *				NULL, 							
 *				NoChild, 						
 *				MetaClass, 						
 *				NULL, 							
 *				NULL, 							
 *				NULL, 							
 *				NULL							
 *			}, {
 *				"#include <X11/Xaw/Box.h>",  	
 *				"Box", 							
 *				"boxWidgetClass", 				
 *				&boxWidgetClass, 				
 *				createNormal, 					
 *				createNormalArgs, 				
 *				MultiChild,						
 *				NormalWidget,					
 *				hasFamily, 						
 *				partsExist, 					
 *				NULL, 							
 *				widgetCreater 					
 *			}, {
 *					
 *					
 *					
 *		
 *		
 ***************************************************************************/
typedef struct _AWidgetInfo {
	const char *publicInclude;
	const char *className;
	const char *variableName;
	WidgetClass *partsClass;
	const char *instance;
	int *argTypes;
	int childExist;
	int type;
	Boolean (*remakable)(struct _AWidgetInfo *myWidget, PartsTree *parts);
	Boolean (*creatable)(struct _AWidgetInfo *myWidget, PartsTree *parts);
	Boolean (*realizable)(struct _AWidgetInfo *myWidget, PartsTree *parts);
	void (*widgetCreation)(struct _AWidgetInfo *myWidget, PartsTree *parts);
	int id;
} AWidgetInfo;

/****************************************************************************
 *	StringsLink: 󥰥롦󥯥ȡꥹȷʻȹ¤
 *	С
 *		char *string;						ʸ
 *		struct _StringsLink *next_ptr;		ؤΥ
 *	
 *		󥯡ݥ󥿤ϡNULL ΤȤü򼨤
 *	
 *	Cd_Order: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *		
 *	λƬ
 *	
 *	ʸ󡡡
 *	
 *	ؤΥ󥯨ʸ󡡡λ
 *	
 *	ؤΥ󥯨ʸ󡡡
 *	
 *	ؤΥ󥯨
 *	
 *	NULLݥ
 *	
 ***************************************************************************/
typedef struct _StringsLink {
	char *string;						/* ʸ */
	struct _StringsLink *next_ptr;		/* ؤΥ */
} StringsLink;

/***************************************************************************
 *	VariableType 
 *	
 *	ͤΰ̣
 *	
 *		μ̻			ΰ̣
 *	
 *		NoArg = 0:				νü
 *		ArgWidget:				åѿ̾
 *		ArgWidgetName:			å̾
 *		ArgWidgetClass:			饹ѿ̾
 *		ArgParent:				ƥåѿ̾
 *		ArgAppContext:			ץꥱ󥳥ƥѿ̾
 *		ArgApplicationClass:	ץꥱ󥯥饹̾
 *		VariableTypeNum:		ϰϥС͡ϰϳѡ
 *	
 *	
 *	
 *		ϡʴ󤫤ʸؿб
 *		Ǥϡʴ˻椫饦åȺ
 *		ؿǰ˻ѤʸФ˻Ѥޤ
 *		argumentArrayProc[] ź˾嵭ꤹȻꤵ줿
 *		ʸФؿؤؿؤΥݥ󥿤Ȥʤ롣
 *		
 *	
 *		μ̻			źѤδؿ
 *	
 *		NoArg:					char *noArg(PartsTree *parts);
 *		ArgWidget:				char *argWidget(PartsTree *parts);
 *		ArgWidgetName:			char *argWidgetName(PartsTree *parts);
 *		ArgWidgetClass:			char *argWidgetClass(PartsTree *parts);
 *		ArgParent:				char *argParent(PartsTree *parts);
 *		ArgAppContext:			char *argAppContext(PartsTree *parts);
 *		ArgApplicationClass:	char *argApplicationClass(PartsTree *parts);
 *		VariableTypeNum:		
 *	
 *		
 *		argumentArrayProc[NoArg](parts) ϡnoArg(parts) Ǥꡢ
 *		argumentArrayProc[ArgWidget](parts) ϡargWidget(parts) Ȥʤ
 *		
 ***************************************************************************/
typedef enum _variableType {
	NoArg = 0, ArgWidget, ArgWidgetName, ArgWidgetClass, ArgParent,
	ArgAppContext, ArgApplicationClass, VariableTypeNum
} VariableType;

extern char *(*argumentArrayProc[])(PartsTree *parts);

/***************************************************************************
 *	ComponentSeparatorType 
 *	
 *	ͤΰ̣
 *	
 *		μ̻			ΰ̣
 *	
 *		NoSeparatorType = 0:	̤ѡList radioData  0 ϻȤʤ
 *		TightBinding:			̩'.'
 *		LooseBinding:			·'*'
 *		ComponentSeparatorNum:	ϰϳѡ
 *	
 *	
 *	
 *		ComponentSeparatorType ϡץꥱǥեȥե
 *		꥽ԤΥݡͥʬηҤǤ
 *		ݡͥȤȤϡΥ饤ʬǤ
 *		
 *		*acconv*mguiCommandMenu.shapeStyle: Oval
 *		~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *		
 *		
 ***************************************************************************/
typedef enum _ComponentSeparatorType {
	NoSeparatorType = 0, TightBinding, LooseBinding, ComponentSeparatorNum
} ComponentSeparatorType;

/***************************************************************************
 *	ComponentWidgetType ΰ̣
 *	
 *	ͤΰ̣
 *	
 *		μ̻				ΰ̣
 *	
 *		NoComponentWidgetType = 0:	̤ѡListradioData0ϻȤʤ
 *		ComponentWidgetName:		å̾
 *		ComponentClassName:			饹̾
 *		ComponentAnyWidget:			餫Υåȡ'?'
 *		ComponentAnyChainWidget:	ĤΥ٥Υåȡ'*'
 *		ComponentSeparatorNum:		ϰϳѡ
 *	
 *	
 *	
 *		ComponentSeparatorType ϡץꥱǥեȥե
 *		꥽ԤΥݡͥʬΥ֥ȡʤޤϥ꥽
 *		Ǥ
 *		ݡͥȤȤϡΥ饤ʬǤ
 *		
 *		*acconv*mguiCommandMenu.shapeStyle: Oval
 *		~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ***************************************************************************/
typedef enum _ComponentWidgetType {
	NoComponentWidgetType = 0, ComponentWidgetName, ComponentClassName, 
	ComponentAnyWidget, ComponentAnyChainWidget, ComponentWidgetTypeNum
} ComponentWidgetType;

/*****************************************************
 *	ץꥱ󡦥꥽Υ꥽̾饹̾
 *****************************************************/
#define XtNhelp				"help"
#define XtCHelp				"Help"
#define XtNmessages			"messages"
#define XtCMessages			"Messages"
#define	XtNjencoding		"jencoding"
#define	XtCJencoding		"Jencoding"

#define ENCODING_DIR		"ja:ja_JP.eucJP\n\
	ja_JP:ja_JP.eucJP\n\
	ja_JP.ujis:ja_JP.eucJP\n\
	ja_JP.eucJP:ja_JP.eucJP\n\
	Jp_JP:ja_JP.eucJP\n\
	ja_JP.AJEC:ja_JP.eucJP\n\
	ja_JP.EUC:ja_JP.eucJP\n\
	ja_JP.ISO-2022-JP:ja_JP.JIS7\n\
	ja_JP.JIS:ja_JP.JIS7\n\
	ja_JP.jis7:ja_JP.JIS7\n\
	ja_JP.mscode:ja_JP.SJIS\n\
	ja_JP.SJIS:ja_JP.SJIS\n\
	japanese:ja_JP.eucJP\n\
	japan:ja_JP.eucJP\n\
	Japanese-EUC:ja_JP.eucJP"

/*****************************************************
 *	ץꥱ󡦥꥽Υ꥽̾饹̾
 *****************************************************/
typedef struct {
	String messages;
	Boolean help;
	String jencoding;
} AppData, *AppDataPtr;

/***************************************************************************
 *	ץȥס
 ***************************************************************************/

void PopupNamingDialog(Widget w, XtPointer client_data, XtPointer call_data);
void NamingDialogSet(Widget w, XtPointer client_data, XtPointer call_data);
void NamingDialogPopdown(Widget w, XtPointer client_data, XtPointer call_data);
void partsMap(Widget w, XtPointer client_data, XtPointer call_data);
void partsUnmap(Widget w, XtPointer client_data, XtPointer call_data);
void partsMapAuto(Widget w, XtPointer client_data, XtPointer call_data);
void PopdownAncestorShell(Widget w, XtPointer client_data, XtPointer call_data);
void partsPopup(Widget w, XtPointer client_data, XtPointer call_data);
void partsPopdown(Widget w, XtPointer client_data, XtPointer call_data);

void partsClearAll(Widget w, XtPointer client_data, XtPointer call_data);
void partsWidgetVariable(Widget w, 
								XtPointer client_data, XtPointer call_data);
void partsWidgetName(Widget w, XtPointer client_data, XtPointer call_data);
void partsClassNames(Widget w, XtPointer client_data, XtPointer call_data);
void partsWidgetAndClassNames(Widget w, 
								XtPointer client_data, XtPointer call_data);
void partsResourceBox(Widget w, XtPointer client_data, XtPointer call_data);
void makeResourceBox(PartsTree *parts);
Widget createRenameShell(Widget parent);
void createResourceFile(Widget parent);
void setNames(Widget w, XtPointer client_data, XtPointer call_data);

extern Widget topLevel;

StringsLink *stringAlloc(const char *string);
StringsLink *stringsAlloc(const char *string);
void stringRelease(StringsLink *string);
StringsLink *stringConnect(StringsLink *strings1, StringsLink *strings2);
int stringsLinkLength(StringsLink *strings);
String stringsLink2string(StringsLink *strings);

void PopdownAncestorShell(Widget w, XtPointer client_data, XtPointer call_data);
char *noArg(PartsTree *parts);
char *argWidget(PartsTree *parts);
char *argWidgetName(PartsTree *parts);
char *argWidgetClass(PartsTree *parts);
char *argParent(PartsTree *parts);
char *argAppContext(PartsTree *parts);
char *argApplicationClass(PartsTree *parts);
char *argClassName(PartsTree *parts);
char *argDummyClassName(PartsTree *parts);

void readAppdefaultFile(const char *appClassName);
void makeResourceManager(Widget w, XtPointer client_data, XtPointer call_data);

char *variableNaming(PartsTree *parts, String name_ptr);
const char *keyword2mes(const char *keyword);

#endif	/*ATHENA_PREVIEWER*/

