/***************************************************************************
 *	resource.c: Athena Widget -> Code Conveterter ꥽
 *				~                ~    ~~~~
 *			Date. 1995/12/24 -- 1998/09/15
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1983,1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************************
 *	øɸ饤֥Υ󥯥롼ɥե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

/*************************************
 *	X Toolkit Υ󥯥롼ɥե
 *************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

/*****************************************
 *	Athena Widget Υ󥯥롼ɥե
 *****************************************/
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>

/***********************************************
 *	ץꥱѥ󥯥롼ɥե
 ***********************************************/
#include "acconv.h"

/***********************************************
 *	Хѿ
 ***********************************************/
extern Widget topLevel;
Widget namesAndClasses;
Widget mguiResWidget;
Widget mguiNormalResources;
Widget mguiConstraintResources;

StringsLink *appDefaultResources = NULL;
StringsLink *appendResources = NULL;

typedef struct _ComponentWidgets {
	PartsTree *parts;		/*  */
	Widget dot;				/* ̩ */
	Widget star;			/* · */
	Widget name;			/* å̾ */
	Widget class;			/* 饹̾ */
	Widget single;			/* 餫Υåȡ? */
	Widget any;				/* åȡΤɤ줫* */
} ComponentResources;

int ComponentsLevel;
ComponentResources *ComponentsInfo;
extern char *HomeDirectory;

Widget mguiResourceFileShell, mguiResFileArea;
Widget mguiResFileIoArea, mguiResFilePopdown, mguiResFileSave;
Widget mguiResFileLoad, mguiResFilename, mguiResFileDefault;
Widget mguiResFileDefText, mguiResFileAppend, mguiResFileAppText;

/***************************************************************************
 *	freeAtDestroy: client_data ǻꤵ줿
 *	
 *		void freeAtDestroy(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤ѡ̾ϡ˲륦åȡ
 *		XtPointer client_data;	ؤݥ
 *		XtPointer call_data;	̤
 *	
 *		
 *		XtNdestroyCallback ǸƤӽФޤ
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		꥽	mguiNormalResources	꥽Ϣ˴
 *						mguiConstraintResources	
 *						ʥꥹȥܥå		
 *	
 *		꥽	namesAndClasses			ľܤΥХå
 *			ġ							ݡͥȴϢ
 *												˴
 *	
 *		
 ***************************************************************************/
void freeAtDestroy(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtFree(client_data);
}

/***************************************************************************
 *	finishedAndDestroy: ꥽ܥå˲
 *	
 *		void finishedAndDestroy(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	˲륦å
 *		XtPointer call_data;	̤
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		꥽	finishedAndDestroy		mguiResourceShell ˴
 *	
 *		
 ***************************************************************************/
void finishedAndDestroy(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtDestroyWidget((Widget)client_data);
}

/***************************************************************************
 *	asciiResourceComp: ɽǥȤ뤿Ӵؿ
 *	
 *		int asciiResourceComp(const void *file1, const void *file2);
 *	
 *		const void *file1;		ե
 *		const void *file2;		ե
 *	֤
 *		-1:	裱裲ΰ֤ˤ
 *		 0: 裱裲
 *		+1:	裱裲ΰ֤ˤ
 *	
 *		ɽǥȤ뤿Ӵؿɤˤ
 *		Ӥեμʰ̥ե뤫ǥ쥯ȥ꤫ˤˤӤ
 *		ͥ褵롣
 *		
 ***************************************************************************/
int asciiResourceComp(const void *resource1, const void *resource2)
{
	int status;
	XtResource *resource1_ptr = *(XtResource**)resource1;
	XtResource *resource2_ptr = *(XtResource**)resource2;

	status = strcmp(resource1_ptr->resource_name, 
									resource2_ptr->resource_name);
	return(status);
}

/***************************************************************************
 *	makeResourceArray: ꥽ʸ
 *	
 *		char **makeResourceArray(XtResource **resources, 
 *											Cardinal numOfResources);
 *	
 *		XtResource **resources;		꥽ؤݥ
 *		Cardinal numOfResources;	꥽
 *	֤
 *		NULL:		顼
 *		NULLʳ:	ʸΤˤϡʸ򺹤ݥ
 *	
 *		Ϳ줿꥽ؤΥݥ󤫤顢NULL ݥ󥿤ü
 *		ˤĥݥ롣줾Υݥ󥿤ϡ꥽̾ʸ
 *		ؤޤ
 *		
 *		Τ褦ʥǡʸΤϡList å
 *		ǻѤ뤿Ǥ
 *		
 *		ʤγԤΤϡݥʬʤΤǡ
 *		void nullTerminatedPointerArrayFree(void **pointerArray);
 *		ѤƲ뤳ȤϤǤʤ
 *		
 *		
 *		pointerArrayġݥѤ˳Ƥ줿
 *		ΰؤ
 *		
 *		ΰ
 *		
 *		
 *		
 *		źΥݥ󥿨
 *		
 *		źΥݥ󥿨
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		źΥݥ󥿨
 *		
 *		
 *		
 *		 ǸΥݥ NULL
 *		ݥ󥿡
 *		
 *		
 *		Ȥ줿꥽󡡨
 *		
 *	
 *	Υ꥽¤Ρ֤Υ꥽¤Ψ
 *	ؤΥݥ󡡡Υ꥽̾
 *	
 *	źΥݥ󥿨resource_name 
 *	XtResource
 *	źΥݥ󥿨¤Ρresource_class
 *	
 *	
 *	
 *	
 *	
 *	resource_name 
 *	
 *	
 *	
 *	
 *	
 *	źΥݥ󥿨resource_name 
 *	
 *	
 *	
 *	 ǸΥݥ 
 *	
 *	NULL
 *	ݥ󥿡
 *	
 *	
 *	
 *		
 *		꥽ꥹ
 *		
 *		resource_name 
 *		
 *		resource_class
 *		
 *		resource_type 
 *		
 *		XtResourceresource_size 
 *		¤Ρ
 *		resource_offset  
 *		
 *		default_type
 *		
 *		default_addr
 *		
 *		resource_name 
 *		
 *	Ȼ
 *		void nullTerminatedPointerArrayFree(void **pointerArray);
 *		
 ***************************************************************************/
char **makeResourceArray(XtResource **resources, Cardinal numOfResources)
{
	int counter;
	char **resourceList;

	/* ݥѤΥݤ */
	resourceList = (char**)XtMalloc(sizeof(char *) * (numOfResources+1));
	if(resourceList != NULL) {
		/* ꥽̾ꥹȤ */
		for(counter = 0;counter < numOfResources;++counter) {
			*(resourceList+counter) = (*(resources+counter))->resource_name;
		}
	}
	*(resourceList + numOfResources) = NULL;	/* üNULLˤ */
	return(resourceList);
}

/***************************************************************************
 *	makeResourcePointerArray: ꥽ؤݥ
 *	
 *		XtResource **makeResourcePointerArray(XtResourceList resources, 
 *												Cardinal numOfResources);
 *	
 *		XtResourceList resources;	꥽ꥹ
 *		Cardinal numOfResources;	꥽
 *	֤
 *		NULL:		顼
 *		NULLʳ:	꥽ؤݥ
 *	
 *		δؿǤϡ꥽ؤݥѤΥơ
 *		ʲΤ褦ʥǡ¤롣
 *		
 *		
 *		resourceArrayList ġݥѥΰؤ
 *		
 *		
 *		ΰ
 *		
 *		
 *		Υ꥽ꥹ
 *		źΥݥ󥿨
 *		resource_name 
 *		źΥݥ󥿨
 *		resource_class
 *		
 *		resource_type 
 *		źΥݥ󥿨XtResource
 *		¤Ρresource_size 
 *		
 *		*resourcesresource_offset  
 *		 ǸΥݥ NULL
 *		ݥ󥿨default_type
 *		
 *		default_addr
 *		
 *		resource_name 
 *		
 *		resource_class
 *		
 *		resource_type 
 *		
 *		XtResourceresource_size 
 *		¤Ρ
 *		resource_offset  
 *		
 *		default_type
 *		
 *		default_addr
 *		
 *		resource_name 
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		resource_name 
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 *		
 ***************************************************************************/
XtResource **makeResourcePointerArray(XtResourceList resources, 
												Cardinal numOfResources)
{
	int counter;
	XtResource **resourceArrayList;

	resourceArrayList = 
		(XtResource**)XtMalloc(sizeof(XtResource*) * (numOfResources+1));
	if(resourceArrayList != NULL) {
		for(counter = 0;counter < numOfResources;++counter) {
			*(resourceArrayList+counter) = resources+counter;
			/* printf("%s\n", (resources+counter)->resource_type); */
		}
		*(resourceArrayList + numOfResources) = NULL;
	}
	return(resourceArrayList);
}

/***************************************************************************
 *	makeResourceList: ꥽ꥹȤꥹȥܥå
 *	
 *		char **makeResourceList(Widget widget, 
 *						WidgetClass widgetClass, 
 *						void (*getResourceList)(WidgetClass, 
 *									XtResourceList*, Cardinal*));
 *	
 *		Widget widget;								Listbox å
 *		WidgetClass widgetClass;					꥽륯饹
 *		void (*getResourceList)(WidgetClass, 
 *					XtResourceList*, Cardinal*));	꥽ؿ
 *								
 *	֤
 *		Ͽʸ
 *	
 *		δؿǤϡꤵ줿ꥹȥܥå˻ꤵ줿饹Υ꥽
 *		ꤵ줿ˡǼʢˤ꥽ꥹȤꤹ롣
 *		
 *		ǡ̾Υ꥽󥹥ȥ쥤ȥ꥽򤬲ǽ
 *		
 *		mguiNormalResources
 *		mguiConstraintResources
 *
 *		
 ***************************************************************************/
char **makeResourceList(Widget widget, WidgetClass widgetClass, 
	void (*getResourceList)(WidgetClass, XtResourceList*, Cardinal*))
{
	int counter;
	char **resourceList;
	XtResourceList resources;
	Cardinal numOfResources;
	XtResource **resourceArrayList;

 	/***********************************************************
 	 *	 (*getResourceList)() ʥ꥽ؿ
 	 *	ꡢ꥽ꥹȤ
 	 ***********************************************************/
	getResourceList(widgetClass, &resources, &numOfResources);
	/* ꥽̾ǥȤ뤿Υݥ */
	resourceArrayList = 
			makeResourcePointerArray(resources, numOfResources);
	if(numOfResources > 0 && resourceArrayList != NULL) {
		/* ꥽ΥꥹȤƤޤ */
		XtAddCallback(widget, 
					XtNdestroyCallback, freeAtDestroy, resources);
		XtAddCallback(widget, 
					XtNdestroyCallback, freeAtDestroy, resourceArrayList);
		/* ꥽ꥹȤ򥢥˥Ȥޤ */
		qsort(resourceArrayList, numOfResources, 
					sizeof(*resourceArrayList), asciiResourceComp);
		resourceList = 
			makeResourceArray(resourceArrayList, numOfResources);
		if(resourceList != NULL) {
			/* List åȤϿ */
			XawListChange(widget, 
							resourceList, numOfResources, 0, True);
			XtAddCallback(widget, 
						XtNdestroyCallback, freeAtDestroy, resourceList);
		}
	}
	return(resourceList);
}

/***************************************************************************
 *	anyWidget?١Ѥδؿ
 *	
 *		char *anyWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;		ʾ̤ѡ
 *	֤
 *		ˡʸؤΥݥ
 *	
 *		?١Ѥδؿ
 ***************************************************************************/
char *anyWidget(PartsTree *parts)
{
	return("?");
}

/***************************************************************************
 *	getResourceString򤵤Ƥ꥽ʸ
 *	
 *		char *getResourceString(void);
 *	֤
 *		򤵤Ƥ꥽ʸ
 *	
 *	
 ***************************************************************************/
char *getResourceString(void)
{
	char *resourceString;
	XawListReturnStruct *currentPane;

	currentPane = XawListShowCurrent(mguiNormalResources);
	if(mguiConstraintResources != NULL && 
							currentPane->list_index == XAW_LIST_NONE) {
		currentPane = XawListShowCurrent(mguiConstraintResources);
	}
	if(currentPane->list_index == XAW_LIST_NONE) {
		resourceString = "unknown";
	} else {
		resourceString = currentPane->string;
	}
	return(resourceString);
}

/***************************************************************************
 *	makeComponentStringݡͥ󤫤ʸ
 *	
 *		char *makeComponentString(ComponentResources *components, 
 *									int level, const char *resourceName);
 *	
 *		ComponentResources *components;	ݡͥȾ
 *		int level;						ݡͥȾʿ
 *		const char *resourceName;	꥽̾
 *									NULL ξϡȤΤΤ򸡺
 *	
 *		ݡͥ󤫤꥽ѤΥݡͥʸ
 *		롣
 ***************************************************************************/
char *makeComponentString(ComponentResources *components, 
							int level, const char *resourceName)
{
	int counter;
	int separatorIdentifer;
	int widgetIdentifer = 0;
	char *string_ptr;
	static char componentString[1024];
	static const char *separator[] = {"", ".", "*"};
	static char *(*componentArrayProc[])(PartsTree *parts) = {
		noArg, argWidget, argClassName, anyWidget, noArg
	};

	string_ptr = componentString;
	for(counter = 0;counter < level;++counter) {
		separatorIdentifer = 
					(int)XawToggleGetCurrent((components+counter)->dot);
		if(widgetIdentifer != ComponentAnyChainWidget) { 
			string_ptr += sprintf(string_ptr, 
									"%s", separator[separatorIdentifer]);
		} else {
			XawToggleSetCurrent((components+counter)->dot, 
												(XtPointer)LooseBinding);
		}
		if((components+counter)->name != NULL) {
			widgetIdentifer = 
					(int)XawToggleGetCurrent((components+counter)->name);
			string_ptr += sprintf(string_ptr, "%s", 
							componentArrayProc[widgetIdentifer](
											(components+counter)->parts));
			if(widgetIdentifer == ComponentAnyChainWidget) { 
				XawToggleSetCurrent((components+counter)->dot, 
												(XtPointer)LooseBinding);
			}
		}
	}
	if(resourceName == NULL) {
		string_ptr += sprintf(string_ptr, "%s", getResourceString());
	} else {
		string_ptr += sprintf(string_ptr, "%s", resourceName);
	}

	return(componentString);
}

/***************************************************************************
 *	emulateComponentStringݡͥ󤫤ʸ
 *	
 *		char *emulateComponentString(ComponentResources *components, 
 *									int level, const char *resourceName);
 *	
 *		ComponentResources *components;	ݡͥȾ
 *		int level;						ݡͥȾʿ
 *		const char *resourceName;	꥽̾
 *									NULL ξϡȤΤΤ򸡺
 *	
 *		ݡͥ󤫤꥽ѤΥݡͥʸ
 *		롣
 ***************************************************************************/
char *emulateComponentString(ComponentResources *components, 
							int level, const char *resourceName)
{
	int counter;
	int separatorIdentifer;
	int widgetIdentifer = 0;
	char *string_ptr;
	static char componentString[1024];
	static const char *separator[] = {"", ".", "*"};
	static char *(*emulateArrayProc[])(PartsTree *parts) = {
		noArg, argWidget, argDummyClassName, anyWidget, noArg
	};

	string_ptr = componentString;
	for(counter = 0;counter < level;++counter) {
		separatorIdentifer = 
					(int)XawToggleGetCurrent((components+counter)->dot);
		if(widgetIdentifer != ComponentAnyChainWidget) { 
			string_ptr += sprintf(string_ptr, 
									"%s", separator[separatorIdentifer]);
		} else {
			XawToggleSetCurrent((components+counter)->dot, 
												(XtPointer)LooseBinding);
		}
		if((components+counter)->name != NULL) {
			widgetIdentifer = 
					(int)XawToggleGetCurrent((components+counter)->name);
			string_ptr += sprintf(string_ptr, "%s", 
							emulateArrayProc[widgetIdentifer](
											(components+counter)->parts));
			if(widgetIdentifer == ComponentAnyChainWidget) { 
				XawToggleSetCurrent((components+counter)->dot, 
												(XtPointer)LooseBinding);
			}
		}
	}
	if(resourceName == NULL) {
		string_ptr += sprintf(string_ptr, "%s", getResourceString());
	} else {
		string_ptr += sprintf(string_ptr, "%s", resourceName);
	}

	return(componentString);
}

/***************************************************************************
 *	convertResourceList 򤵤줿꥽̾
 *	
 *		char *convertResource(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;					̤
 *		XtPointer client_data;		̤
 *		XtPointer call_data;		ܤ˴ؿ
 *	֤
 *		NULL: 		򤵤Ƥʤ
 *		NULLʳ: 	򤵤줿꥽̾
 *	
 *		List ΥХåؿ򤵤줿꥽̾
 *	
 ***************************************************************************/
char *convertResource(Widget w, XtPointer client_data, XtPointer call_data)
{
	char *resourceName = NULL;
	XawListReturnStruct *currentPane = (XawListReturnStruct*)call_data;

	if(currentPane->list_index != XAW_LIST_NONE) {
		resourceName = currentPane->string;
	}
	return(resourceName);
}

/***************************************************************************
 *	remakeComponentݡͥʸιԤ
 *	
 *		void remakeComponent(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				client_data ꤵƤʤ硢̤
 *		XtPointer client_data;	꥽̾ѴؿNULLʤ饫Ȥ
 *		XtPointer call_data;	client_data ꤵƤʤ硢̤
 *	
 *		ݡͥʸ Toggle ˤʸ򹹿롣
 *		
 *		̼ΥХåؿƤ֥åȤ󵭤롣
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		꥽			dot				ľܤΥХåؿ
 *		namesAndClasses		...->dot	
 *	
 *		꥽			star			ľܤΥХåؿ
 *		namesAndClasses		...->star					
 *	
 *		꥽			name			ľܤΥХåؿ
 *		namesAndClasses		...->name					
 *	
 *		꥽			class			ľܤΥХåؿ
 *		namesAndClasses		...->class					
 *	
 *		꥽			single			ľܤΥХåؿ
 *		namesAndClasses		...->single					
 *	
 *		꥽			any				ľܤΥХåؿ
 *		namesAndClasses		...->any			
 *	
 *		꥽	mguiNormalResources		ľܤΥХåؿ
 *	
 *		꥽	mguiConstraintResources	ľܤΥХåؿ
 *	
 *		
 *		ġΥåȤΰ̣򼨤ϡǤص̾Ǥ롣
 *		   dot    . .............. ̩ꤹ
 *		   star   * .............. ·ꤹ
 *		   name   ȥå̾.. å̾ꤹ
 *		   class  ȥ饹̾........ 饹̾ꤹ
 *		   single ? .............. ǤդΥåȤ̣
 *		   any    * .............. ǤդΥạ̊
 *		   mguiNormalResources ....... ꥽̾ꤹ
 *		   mguiConstraintResources ... 󥹥ȥ쥤ȥ꥽̾
 *		
 ***************************************************************************/
void remakeComponent(Widget w, XtPointer client_data, XtPointer call_data)
{
	char componentString[1024];
	char *resourceName = NULL;
	char *(*convertResourcename)(Widget w, 
				XtPointer client_data, XtPointer call_data) = client_data;

	if(convertResourcename != NULL) {
		resourceName = convertResourcename(w, client_data, call_data);
	}
	sprintf(componentString, "%s :", 
		makeComponentString(ComponentsInfo, ComponentsLevel, resourceName));
	XtVaSetValues(mguiResWidget, XtNlabel, componentString, NULL);
}

/***************************************************************************
 *	makePartsOfComponentʬΥݡͥȤѤΥ饸ܥ
 *	
 *		void makePartsOfComponent(PartsTree *parts, 
 *								int level, XtPointer client_data);
 *	
 *		PartsTree *parts;		
 *		int level;				٥ʺǾ̤Ʋܤ򼨤
 *		XtPointer client_data;	ݡͥȾǼ
 *	
 *		δؿǤϡοޤκ¦ηʬȡ¦ΥåȤʬ
 *		ޤ¦ΥåȤʬϡ parts NULL Τ
 *		ϡޤ
 *		
 *		
 *		硡åȻʬ
 *		
 *		[.] [  widget-name   ]
 *		[*] [   class-name   ]
 *		[   Any Widget   ]
 *		[Any Widget Chain]
 *		
 *		
 *		嵭Τ褦˥ݡͥȤΣʬޤ
 *		
 ***************************************************************************/
void makePartsOfComponent(PartsTree *parts, int level, XtPointer client_data)
{
	ComponentResources *myComponents;
	ComponentResources *components = (ComponentResources*)client_data;
	
	myComponents = components+level;

	myComponents->parts = parts;

	/*******************************************
	 *	ʬ򼨤 radio group 
	 *******************************************/
	/* ̩򼨤.ɤ Toggle  */
	myComponents->dot = XtVaCreateManagedWidget(
							"dot",
							toggleWidgetClass,
							namesAndClasses,
							XtNlabel, ".", 
							XtNradioData, TightBinding, 
							NULL);
	/* ·򼨤*ɤ Toggle  */
	myComponents->star = XtVaCreateManagedWidget(
							"star",
							toggleWidgetClass,
							namesAndClasses,
							XtNlabel, "*", 
							XtNfromVert, myComponents->dot,
							XtNradioData, LooseBinding, 
							NULL);

	XawToggleChangeRadioGroup(myComponents->dot, myComponents->star);
	XawToggleSetCurrent(myComponents->dot, (XtPointer)TightBinding);
	XtAddCallback(myComponents->dot, XtNcallback, remakeComponent, NULL);
	XtAddCallback(myComponents->star, XtNcallback, remakeComponent, NULL);

	if(parts != NULL) {
		/**************************************************
		 *	åʬ򼨤 radio group 
		 **************************************************/
		myComponents->name = XtVaCreateManagedWidget(
								"name",
								toggleWidgetClass,
								namesAndClasses,
								XtNlabel, parts->widgetName, 
								XtNfromHoriz, myComponents->dot,
								XtNstate, True, 
								XtNradioData, ComponentWidgetName, 
								NULL);

		myComponents->class = XtVaCreateManagedWidget(
								"class",
								toggleWidgetClass,
								namesAndClasses,
								XtNlabel, argClassName(parts), 
								XtNfromHoriz, myComponents->dot,
								XtNfromVert, myComponents->dot,
								XtNradioData, ComponentClassName, 
								NULL);

		myComponents->single = XtVaCreateManagedWidget(
								"single",
								toggleWidgetClass,
								namesAndClasses,
								XtNlabel, "Any Widget", 
								XtNfromHoriz, myComponents->dot,
								XtNfromVert, myComponents->star, 
								XtNradioData, ComponentAnyWidget, 
								NULL);

		myComponents->any = XtVaCreateManagedWidget(
								"any",
								toggleWidgetClass,
								namesAndClasses,
								XtNlabel, "Any Widget Chain", 
								XtNfromHoriz, myComponents->dot,
								XtNfromVert, myComponents->single, 
								XtNradioData, ComponentAnyChainWidget, 
								NULL);

		XawToggleChangeRadioGroup(myComponents->name, myComponents->class);
		XawToggleChangeRadioGroup(myComponents->single, myComponents->name);
		XawToggleChangeRadioGroup(myComponents->any, myComponents->name);
		XawToggleSetCurrent(myComponents->name, (XtPointer)1);
		XtAddCallback(myComponents->name, XtNcallback, remakeComponent, NULL);
		XtAddCallback(myComponents->class, XtNcallback, remakeComponent, NULL);
		XtAddCallback(myComponents->single, XtNcallback, remakeComponent, NULL);
		XtAddCallback(myComponents->any, XtNcallback, remakeComponent, NULL);
	}
	if(level > 0) {
		/**********************************************************
		 *	Form åȤΰִطĴޤʺǾ̰ʳ
		 **********************************************************/
		XtVaSetValues(myComponents->dot, XtNfromHoriz, 
								(components+level-1)->any, NULL);
		XtVaSetValues(myComponents->star, XtNfromHoriz, 
								(components+level-1)->any, NULL);
	}
}

/***************************************************************************
 *	PartsAncestorTraceGUIѡĤΥĥ꡼¤Ƥؤफäƥȥ졼
 *	
 *		void PartsAncestorTrace(PartsTree *parts, 
 *							int level, XtPointer client_data, 
 *							void (*PartsProc)(PartsTree *parts, 
 *										int level, XtPointer client_data));
 *	
 *		PartsTree *parts;			
 *		int level;					ʲ˥ȥ졼뤫򼨤٥
 *		XtPointer client_data, 		ݡͥȾ
 *		void (*PartsProc)(PartsTree *parts, 
 *				int level, XtPointer client_data));		ʺؿ
 *	
 *		δؿϡꥫ֥ʺƵƤӽФˤǼʬȤƤӽФ
 *		ơƤ˸äƥȥ졼롣
 *		ƤӽФλ顢Ƥ饳ݡͥȻѤʤ
 *		ޤ
 *	
 ***************************************************************************/
void PartsAncestorTrace(PartsTree *parts, int level, XtPointer client_data, 
		void (*PartsProc)(PartsTree *parts, int level, XtPointer client_data))
{
	if(parts != NULL) {
		if(parts->parent_ptr != NULL && level > 0) {
			/* ƤذܹԤ */
			PartsAncestorTrace(parts->parent_ptr, 
									level-1, client_data, PartsProc);
		}
		if(PartsProc != NULL) {
			/* ʤФƲ餫κѤ򤹤ؿ */
			PartsProc(parts, level, client_data);
		}
	}
}

/***************************************************************************
 *	resizeComponentݡͥ󤫤ʤθɤɤ
 *	
 *		void resizeComponent(ComponentResources *components, int level);
 *	
 *		ComponentResources *components;	ݡͥȾ
 *		int level;						ݡͥȾʿ
 *	
 *		ݡͥ󤫤꥽ѤΥݡͥʸ
 *		롣
 *		
 ***************************************************************************/
void resizeComponent(ComponentResources *components, int level)
{
	int counter;
	Dimension width, maxWidth;

	for(counter = 0;counter <= level;++counter) {
#ifdef	DEBUG
		printf("%s:%d:resizeComponent();\n", __FILE__, __LINE__);
#endif	/*DEBUG*/
		maxWidth = 0;
#ifdef	DEBUG
		printf("%s:%d:resizeComponent();:dos[%p]/star[%p]\n", 
					__FILE__, __LINE__,
					(components+counter)->dot, (components+counter)->star);
#endif	/*DEBUG*/
		if((components+counter)->dot != NULL && 
									(components+counter)->star != NULL) {
			/*****************************************
			 *	·硿̩ĹĴ
			 *****************************************/
			XtVaGetValues((components+counter)->dot, XtNwidth, &width, NULL);
			maxWidth = width;
			XtVaGetValues((components+counter)->star, XtNwidth, &width, NULL);
			if(width > maxWidth)
				maxWidth = width;
			XtVaSetValues((components+counter)->dot,  XtNwidth, maxWidth, NULL);
			XtVaSetValues((components+counter)->star, XtNwidth, maxWidth, NULL);
#ifdef	DEBUG
			printf("%s:%d:resizeComponent();:name(=%p)/class(=%p)/?(=%p)/*(=%p)\n",
					__FILE__, __LINE__, 
					(components+counter)->name, (components+counter)->class, 
					(components+counter)->single, (components+counter)->any);
#endif	/*DEBUG*/
			if((components+counter)->name != NULL) {
				/***********************************************
				 *	ʲΥåȤĴ
				 *		å̾
				 * 		饹̾
				 *		Ǥեå(Any Widget)
				 *		Ϣ³륦å(Any Widget Chain)
				 ***********************************************/
				maxWidth = 0;
				XtVaGetValues((components+counter)->name, XtNwidth, &width, NULL);
				maxWidth = width;
				XtVaGetValues((components+counter)->class, XtNwidth, &width, NULL);
				if(width > maxWidth)
					maxWidth = width;
				XtVaGetValues((components+counter)->single, XtNwidth, &width, NULL);
				if(width > maxWidth)
					maxWidth = width;
				XtVaGetValues((components+counter)->any, XtNwidth, &width, NULL);
				if(width > maxWidth)
					maxWidth = width;
				XtVaSetValues((components+counter)->name,   XtNwidth, maxWidth, NULL);
				XtVaSetValues((components+counter)->class,  XtNwidth, maxWidth, NULL);
				XtVaSetValues((components+counter)->single, XtNwidth, maxWidth, NULL);
				XtVaSetValues((components+counter)->any,    XtNwidth, maxWidth, NULL);
			}
		}
	}
#ifdef	DEBUG
	printf("%s:%d:resizeComponent();\n", __FILE__, __LINE__);
#endif	/*DEBUG*/
}

/***************************************************************************
 *	makeComponent: ꥽ԤΥݡͥȻʤκ
 *	
 *		void makeComponent(PartsTree *parts, Widget parent);
 *	
 *		PartsTree *parts;	ݡͥȤκоݤȤʤ
 *		Widget parent;		ݡͥȤΥ쥤Ѥ Form ο
 *	֤
 *		ʤ
 *	
 *		꥽ԤΥݡͥȻѤΥåȤ
 *		
 *		
 *		硡åȻꡡ硡åȻꡡ硡
 *		
 *		[.] [  widget-name   ][.] [  widget-name   ][.] 
 *		[*] [   class-name   ][*] [   class-name   ][*] 
 *		[   Any Widget   ][   Any Widget   ]
 *		[Any Widget Chain][Any Widget Chain]
 *		
 *		ʬ
 *		
 *		
 ***************************************************************************/
void makeComponent(PartsTree *parts, Widget parent)
{
	int nest;
	int counter;
	PartsTree *parts_ptr;

	/* Ǿ̤Ʋܤ򥫥Ȥ */
	for(parts_ptr = parts, nest = 0;parts_ptr != NULL;
				parts_ptr = parts_ptr->parent_ptr, ++nest)
		;						/*  */

	/* ݡͥȤɽΤɬפʥݡ */
	ComponentsInfo = (ComponentResources*)
						XtMalloc(sizeof(ComponentResources)*(nest+1));
	for(counter = 0;counter <= nest;++counter) {
		(ComponentsInfo+counter)->parts  = NULL;
		(ComponentsInfo+counter)->dot    = NULL;
		(ComponentsInfo+counter)->star   = NULL;
		(ComponentsInfo+counter)->name   = NULL;
		(ComponentsInfo+counter)->class  = NULL;
		(ComponentsInfo+counter)->single = NULL;
		(ComponentsInfo+counter)->any    = NULL;
	}
	if(ComponentsInfo != NULL && nest > 0) {
		namesAndClasses = XtVaCreateManagedWidget(
					"namesAndClasses",
					formWidgetClass,
					parent,
					NULL);
		/***************************************************************
		 *	ݡͥȤ쥤Ȥ򤹤륦åȤ˴ΤȤ
		 *	ݡͥȻ˻ȤäƤ˴褦Ͽ
		 ***************************************************************/
		XtAddCallback(namesAndClasses, 
						XtNdestroyCallback, freeAtDestroy, ComponentsInfo);
		/***************************************************************
		 *	ݡͥȻΤΥåȺ
		 ***************************************************************/
		PartsAncestorTrace(parts, nest-1, 
					(XtPointer)ComponentsInfo, makePartsOfComponent);
		/* å̾ȥ꥽̾ηΤʺ */
		makePartsOfComponent(NULL, nest, (XtPointer)ComponentsInfo);
		resizeComponent(ComponentsInfo, nest);	/* Ĵ */
		ComponentsLevel = nest+1;
	}
}

/***************************************************************************
 *	UnselectResources: ꤵ줿ꥹȤ
 *	
 *		void UnselectResources(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;					̤
 *		XtPointer client_data;		ȿžɽ줿ܤꥹ
 *		XtPointer call_data;		̤
 *	
 *		ꤵ줿ꥹȤ
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		꥽	mguiNormalResources		꥽ꥹ
 *	
 *		꥽	mguiConstraintResources	󥹥ȥ쥤ȥ꥽
 *												ꥹ
 *	
 *		
 ***************************************************************************/
void UnselectResources(Widget w, XtPointer client_data, XtPointer call_data)
{
	XawListUnhighlight((Widget)client_data);
}

/***************************************************************************
 *	SetResource: ꥽ǡ١ɲä
 *	
 *		void SetResource(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;					ǥץ쥤Τ˻
 *		XtPointer client_data;		꥽ꤹʸѥƥ
 *		XtPointer call_data;		̤
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		꥽	mguiResSet			ľܤΥХå
 *	
 *		
 ***************************************************************************/
void SetResource(Widget w, XtPointer client_data, XtPointer call_data)
{
	int counter;
	int topOfEmulatedString;
	String string;
	Widget resourceText = (Widget)client_data;
	char realResourceBuffer[1024];
	char dummyResourceBuffer[1024];
	XrmDatabase db = NULL;

	/* ꥽ꤹƤμ */
	XtVaGetValues(client_data, XtNstring, &string, NULL);
	db = XtDatabase(XtDisplay(w));		/* ꥽ǡ١μ */
	sprintf(realResourceBuffer, "*%s%n%s:%s", "Acconv", &topOfEmulatedString,
		emulateComponentString(ComponentsInfo, ComponentsLevel, NULL), string);
	for(counter = topOfEmulatedString;realResourceBuffer[counter] == '.' || 
				realResourceBuffer[counter] == '*' || 
							isupper(realResourceBuffer[counter]);++counter) {
		/* ץꥱ󤬥饹ǻꤵƤΤޤ */
		realResourceBuffer[counter] = tolower(realResourceBuffer[counter]);
	}
	/* ꥽εϿ */
	sprintf(dummyResourceBuffer, "%s:%s", 
		makeComponentString(ComponentsInfo, ComponentsLevel, NULL), string);
	appendResources = 
		stringConnect(appendResources, stringAlloc(dummyResourceBuffer));
	XrmPutLineResource(&db, realResourceBuffer);
}

/***************************************************************************
 *	file2StringLink: եΥݤ
 *	
 *		StringsLink *file2StringLink(FILE *stream);
 *	
 *		FILE *stream;		ե롦ݥ
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		եʸ󥯡ݤ롣
 *		
 ***************************************************************************/
StringsLink *file2StringLink(FILE *stream)
{
	int length;
	char buffer[4096];
	const char *line_ptr;
	StringsLink *alloc_ptr = NULL, allocTop;

	alloc_ptr = &allocTop;
	do {
		line_ptr = fgets(buffer, sizeof(buffer), stream);
		if(line_ptr != NULL && (buffer[0] == '.' || 
								buffer[0] == '*' || isalpha(buffer[0]))) {
			line_ptr = (char*)alloc_ptr->next_ptr = stringAlloc(NULL);
			if(alloc_ptr->next_ptr != NULL) {
				length = strlen(buffer);
				length -= (buffer[length-(length>0)] == '\n');
				line_ptr = alloc_ptr->next_ptr->string = 
												(char*)XtMalloc(length+1);
				if(alloc_ptr->next_ptr->string != NULL) {
					alloc_ptr = alloc_ptr->next_ptr;
					sprintf(alloc_ptr->string, "%.*s", length, buffer);
				}
			}
		}
	} while(line_ptr != NULL);
	XtFree((char*)alloc_ptr->next_ptr);
	alloc_ptr->next_ptr = NULL;
	return(allocTop.next_ptr);
}

/***************************************************************************
 *	makeEmulateDatabase: ꥽ǡ١Ͽ
 *	
 *		void makeEmulateDatabase(StringsLink *strings);
 *	
 *		StringsLink *strings;		
 *	
 *		acconv ߥ졼ѤΥ꥽ǡ١Ͽ.
 *		
 *		
 *		
 ***************************************************************************/
void makeEmulateDatabase(StringsLink *strings)
{
	char resourceBuffer[1024];
	XrmDatabase db = NULL;

	db = XtDatabase(XtDisplay(topLevel));

	while(strings != NULL) {
		if(*strings->string == '.' || 
				*strings->string == '*' || isalpha(*strings->string)) {
			sprintf(resourceBuffer, "*%s%s%s", "Acconv", 
				((*strings->string == '.' || 
					*strings->string == '*')?(""):(".")), strings->string);
			/*printf(">>%s\n", strings->string);*/
			XrmPutLineResource(&db, resourceBuffer);
		}
		strings = strings->next_ptr;
	}
}

/***************************************************************************
 *	readResorceFile: ꥽ե
 *	
 *		StringsLink *readResorceFile(const char *filename);
 *	
 *		const char *filename;		꥽ե̾
 *	֤
 *		
 *	
 *		
 *		
 *		
 ***************************************************************************/
StringsLink *readResorceFile(const char *filename)
{
	FILE *fp;
	StringsLink *strings = NULL;

	/*printf("\"%s\" -- Application default file. ", filename);*/
	fp = fopen(filename, "r");
	if(fp != NULL) {
		strings = file2StringLink(fp);
		/*printf("-- Sucessfull.\n");*/
#ifdef	DEBUG
	} else {
		printf("-- Fault.\n");
#endif	/*DEBUG*/
	}
	fclose(fp);
	return(strings);
}

/***************************************************************************
 *	makePath: ǥ쥯ȥΥѥ̾ȥե̾ѥ̾
 *	
 *		char *makePath(const char *dirPath, const char *filename);
 *	
 *		const char *dirPath;		ǥ쥯ȥΥѥ̾
 *		const char *filename;		ե̾
 *	֤
 *		
 *	
 *		NULL:		­
 *		NULLʳ:	ѥ̾
 *	Ȼ
 *		XtFree(); 
 ***************************************************************************/
char *makePath(const char *dirPath, const char *filename)
{
	char *filepath;

	filepath = XtMalloc(strlen(dirPath)+strlen(filename)+2);
	if(filepath != NULL) {
		sprintf(filepath, "%s/%s", dirPath, filename);
	}
	return(filepath);
}

/***************************************************************************
 *	readAppdefaultFile: ץꥱ󥯥饹꥽եɤ
 *	
 *		void readAppdefaultFile(const char *appClassName);
 *	
 *		const char *appClassName;		ץꥱ󥯥饹̾
 *	
 *		ץꥱ󥯥饹饢ץꥱǥեȥե
 *		߽Ф
 *		
 ***************************************************************************/
void readAppdefaultFile(const char *appClassName)
{
	FILE *fp;
	char *filename;
	StringsLink *strings = NULL;
	char *localAppDef;
	extern char *localeName;

	if(strcmp(localeName, "C") != 0) {
		localAppDef = makePath(LIBDIR, localeName);
		filename = makePath(localAppDef, appClassName);
		if(filename != NULL) {
			strings = stringConnect(strings, readResorceFile(filename));
			XtFree(filename);
		}
		XtFree(localAppDef);
	}
	filename = makePath(APPDEFDIR, appClassName);
	if(filename != NULL) {
		strings = stringConnect(strings, readResorceFile(filename));
		XtFree(filename);
	}
	filename = makePath(HomeDirectory, appClassName);
	if(filename != NULL) {
		strings = stringConnect(strings, readResorceFile(filename));
		XtFree(filename);
	}
	makeEmulateDatabase(strings);
	appDefaultResources = strings;
}

/***************************************************************************
 *	makeResourceBox: ꥽ܥå¸ݥåץå
 *	
 *		void makeResourceBox(PartsTree *parts);
 *	
 *		PartsTree *parts;
 *	
 *		ꤵ줿ʤ˴ؤơ꥽ܥåݥåץåפ
 *		
 *		
 ***************************************************************************/
void makeResourceBox(PartsTree *parts)
{
	char componentString[1024];
	Widget mguiResourceShell;
	Widget mguiResArea, mguiResMenuArea, mguiResourceFile;
	Widget mguiNormalResLabel;
	Widget mguiConstraintRes, mguiResEditArea;
	Widget mguiResEditLabel, mguiResEdit, mguiResCommands;
	Widget mguiResFileSelecter, mguiResSave, mguiResSet, mguiResPopdown;

	mguiResourceShell = XtVaCreatePopupShell(
				"mguiResourceShell",
				transientShellWidgetClass,
				topLevel,
				NULL);

	mguiResArea = XtVaCreateManagedWidget(
				"mguiResArea",
				panedWidgetClass,
				mguiResourceShell,
				NULL);

	mguiResMenuArea = XtVaCreateManagedWidget(
				"mguiResMenuArea",
				boxWidgetClass,
				mguiResArea,
				NULL);

	mguiResourceFile = XtVaCreateManagedWidget(
				"mguiResourceFile",
				menuButtonWidgetClass,
				mguiResMenuArea,
				NULL);

	mguiResWidget = XtVaCreateManagedWidget(
				"mguiResWidget",
				labelWidgetClass,
				mguiResArea,
				NULL);

	makeComponent(parts, mguiResArea);

	mguiNormalResLabel = XtVaCreateManagedWidget(
				"mguiNormalResLabel",
				labelWidgetClass,
				mguiResArea,
				NULL);

	mguiNormalResources = XtVaCreateManagedWidget(
				"mguiNormalResources",
				listWidgetClass,
				mguiResArea,
				NULL);

	XtAddCallback(mguiNormalResources, 
		XtNcallback, remakeComponent, (XtPointer)convertResource);

	if(parts != NULL && parts->partsWidget != NULL) {
		makeResourceList(mguiNormalResources, 
				*parts->athenaInfo->partsClass, XtGetResourceList);
	}

	if(parts != NULL && parts->parent_ptr != NULL &&
			parts->parent_ptr->partsWidget != NULL &&
			XtIsConstraint(parts->parent_ptr->partsWidget)) {
		mguiConstraintRes = XtVaCreateManagedWidget(
					"mguiConstraintRes",
					labelWidgetClass,
					mguiResArea,
					NULL);

		mguiConstraintResources = XtVaCreateManagedWidget(
					"mguiConstraintResources",
					listWidgetClass,
					mguiResArea,
					NULL);

		makeResourceList(mguiConstraintResources, 
				*parts->parent_ptr->athenaInfo->partsClass, 
								XtGetConstraintResourceList);

		XtAddCallback(mguiConstraintResources, 
			XtNcallback, remakeComponent, (XtPointer)convertResource);
		XtAddCallback(mguiConstraintResources, 
			XtNcallback, UnselectResources, mguiNormalResources);
		XtAddCallback(mguiNormalResources, 
			XtNcallback, UnselectResources, mguiConstraintResources);
	} else {
		mguiConstraintResources = NULL;
	}

	sprintf(componentString, "%s :", 
		makeComponentString(ComponentsInfo, ComponentsLevel, NULL));
	XtVaSetValues(mguiResWidget, XtNlabel, componentString, NULL);

	mguiResEditArea = XtVaCreateManagedWidget(
				"mguiResEditArea",
				formWidgetClass,
				mguiResArea,
				NULL);

	mguiResEditLabel = XtVaCreateManagedWidget(
				"mguiResEditLabel",
				labelWidgetClass,
				mguiResEditArea,
				NULL);

	mguiResEdit = XtVaCreateManagedWidget(
				"mguiResEdit",
				asciiTextWidgetClass,
				mguiResEditArea,
				XtNeditType, XawtextEdit,
				XtNtype, XawAsciiString,
				NULL);

	mguiResCommands = XtVaCreateManagedWidget(
				"mguiResCommands",
				boxWidgetClass,
				mguiResArea,
				NULL);

	mguiResFileSelecter = XtVaCreateManagedWidget(
				"mguiResFileSelecter",
				commandWidgetClass,
				mguiResCommands,
				NULL);

	mguiResSave = XtVaCreateManagedWidget(
				"mguiResSave",
				commandWidgetClass,
				mguiResCommands,
				NULL);

	mguiResSet = XtVaCreateManagedWidget(
				"mguiResSet",
				commandWidgetClass,
				mguiResCommands,
				NULL);

	mguiResPopdown = XtVaCreateManagedWidget(
				"mguiResPopdown",
				commandWidgetClass,
				mguiResCommands,
				NULL);
	
	XtAddCallback(mguiResSet, 
					XtNcallback, SetResource, (XtPointer)mguiResEdit);
	XtAddCallback(mguiResPopdown, XtNcallback, PopdownAncestorShell, NULL);
	XtAddCallback(mguiResPopdown, XtNcallback, 
									finishedAndDestroy, mguiResourceShell);

	XtRealizeWidget(mguiResourceShell);
	XtPopup(mguiResourceShell, XtGrabNone);
}

/***************************************************************************
 *	makeResourceManager꥽ɥݥåץåפ
 *	
 *		void makeResourceManager(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;					̤
 *		XtPointer client_data;		ʾ
 *		XtPointer call_data;		̤
 *	
 *		ץꥱǥեȥե뤫Ǥ롢ʸ
 *		Text åȤؤФ
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		˥塼		fileMakeResource		ľܤΥХå
 *						topMenuInfo[6].myWidget ... ѿ̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void makeResourceManager(Widget w, XtPointer client_data, XtPointer call_data)
{
	String longStrings;
	
	if(appDefaultResources != NULL) {
		longStrings = stringsLink2string(appDefaultResources);
		if(longStrings != NULL) {
			XtVaSetValues(mguiResFileDefText, XtNstring, longStrings, NULL);
		}
	}
	if(appendResources != NULL) {
		longStrings = stringsLink2string(appendResources);
		if(longStrings != NULL) {
			XtVaSetValues(mguiResFileAppText, XtNstring, longStrings, NULL);
		}
	}
	XtPopup(mguiResourceFileShell, XtGrabNone);
}

/***************************************************************************
 *	createResourceFile: ꥽ե륷
 *	
 *		void createResourceFile(Widget parent);
 *	
 *		Widget parent;			ƥå
 *	
 *		
 *		
 ***************************************************************************/
void createResourceFile(Widget parent)
{
	mguiResourceFileShell = XtVaCreatePopupShell(
				"mguiResourceFileShell",
				transientShellWidgetClass,
				parent,
				NULL);

	mguiResFileArea = XtVaCreateManagedWidget(
				"mguiResFileArea",
				panedWidgetClass,
				mguiResourceFileShell,
				NULL);

	mguiResFileIoArea = XtVaCreateManagedWidget(
				"mguiResFileIoArea",
				panedWidgetClass,
				mguiResFileArea,
				NULL);

	mguiResFilePopdown = XtVaCreateManagedWidget(
				"mguiResFilePopdown",
				commandWidgetClass,
				mguiResFileIoArea,
				NULL);

	mguiResFileSave = XtVaCreateManagedWidget(
				"mguiResFileSave",
				commandWidgetClass,
				mguiResFileIoArea,
				NULL);

	mguiResFileLoad = XtVaCreateManagedWidget(
				"mguiResFileLoad",
				commandWidgetClass,
				mguiResFileIoArea,
				NULL);

	mguiResFilename = XtVaCreateManagedWidget(
				"mguiResFilename",
				asciiTextWidgetClass,
				mguiResFileIoArea,
				NULL);

	mguiResFileDefault = XtVaCreateManagedWidget(
				"mguiResFileDefault",
				labelWidgetClass,
				mguiResFileArea,
				NULL);

	mguiResFileDefText = XtVaCreateManagedWidget(
				"mguiResFileDefText",
				asciiTextWidgetClass,
				mguiResFileArea,
				NULL);

	mguiResFileAppend = XtVaCreateManagedWidget(
				"mguiResFileAppend",
				labelWidgetClass,
				mguiResFileArea,
				NULL);

	mguiResFileAppText = XtVaCreateManagedWidget(
				"mguiResFileAppText",
				asciiTextWidgetClass,
				mguiResFileArea,
				NULL);

	XtAddCallback(mguiResFilePopdown, XtNcallback, PopdownAncestorShell, NULL);
}

