/***************************************************************************
 *	stringuty.c: ʸ/ñ̽ؿ
 *	
 *	ջ
 *		ߡΥΥѥˤϡX Toolkit Υ饤֥ؿ
 *		ɬפˤʤäƤޤXtMalloc()  malloc() / XtFree()  free()
 *		ؤ֤θƤޤ
 *		ޤXtNewString() ϡNewString() ֤Ǥ褦ˤ
 *		ޤ
 *		ʤXt ǻϤޤݴؿϡ­ΤȤ XtErrorMsg()
 *		ƤӽФ顼Ԥʤޤøɸ饤֥
 *		 malloc()/free() ؤ֤ƤθƤӽФθƥ­
 *		ΤȤ NULL ֤褦ʴؿȤưȤȤ롣
 *	
 *			Date. 1996/05/16(Collected) -- 1996/05/18(First Fix)
 *			Date. 1996/05/22 --
 *		
 *					Programed by Nobuyuki Maruichi
 *	
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
 #include <stdio.h>
 #include <stdlib.h>
 #include <ctype.h>
 #include <stdarg.h>

/***********************************************
 *	X Toolkit δŪʥ󥯥롼ɡե
 ***********************************************/
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */

/********************************
 * ѤΥ󥯥롼ɡե
 ********************************/
#include "stringuty.h"

#ifndef	_XtIntrinsic_h
/***************************************************************************
 *		X Toolkit 饤֥ؿѤʤȤɬפʴؿ
 ***************************************************************************/

/***************************************************************************
 *	NewString: ꤵ줿ʸʣmalloc()Ȥäơ˳ݤ
 *	
 *		char *NewString(const char *string);
 *	
 *		const char *string;		ԡʸ
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		ʸʣʥݤơ
 *		
 ***************************************************************************/
char *NewString(const char *string)
{
	char *alloc_ptr = NULL;
	
	alloc_ptr = (char*)malloc(strlen(string)+1);
	return(alloc_ptr);
}

# define	_string_malloc(size)		malloc(size)
# define	_string_newString(string)	NewString(string)
# define	_string_free(pointer)		free(pointer)
#else
/***************************************************************************
 *		X Toolkit 饤֥ؿѤ
 ***************************************************************************/
# define	_string_malloc(size)		XtMalloc(size)
# define	_string_newString(string)	XtNewString(string)
# define	_string_free(pointer)		XtFree((char*)pointer)
#endif	/*_XtIntrinsic_h*/

/***************************************************************************
 *	asciiStringCaseCmp: ʸ/ʸ̵뤷ĤʸӤ
 *	
 *		int asciiStringCaseCmp(const char *s1, const char *s2);
 *	
 *		const char *s1;		оݤʸ(s1)
 *		const char *s2;		оݤʸ(s2)
 *	֤
 *		:	s1  s2 ⾮
 *		0:			s1  s2 Ʊ
 *		:	s1  s2 礭
 *	
 *		ʸ/ʸ̤Ĥʸ s1  s2 Ӥ롣s1  
 *		s2 ⾮Ʊ礭ˤäƤ줾0
 *		֤
 *	Ȼ
 *		strcasecmp() [BSD4.3]  stricmp() ϡѥ¸δؿʤΤ
 *		λͤƱʴؿȤơޤ
 *		
 ***************************************************************************/
int asciiStringCaseCmp(const char *s1, const char *s2)
{
	int c1, c2;
	int result = 0;

	if(s1 != NULL && s2 != NULL) {
		for(;result == 0 && *s1 != '\0' && *s2 != '\0';++s1, ++s2) {
			if(isalpha(*s1) && isalpha(*s2)) {
				c1 = tolower(*s1);
				c2 = tolower(*s2);
				result = -(c1 < c2) + (c1 > c2);
			} else {
				result = -(*s1 < *s2) + (*s1 > *s2);
			}
		}
		if(result == 0 && (*s1 != '\0' || *s2 != '\0')) {
			result = -(*s1 < *s2) + (*s1 > *s2);
		}
	}
	return(result);
}

/***************************************************************************
 *	lineAlloc: ʬΥݤ
 *	
 *		LineLink *lineAlloc(const char *string);
 *	
 *		const char *string;		ݤֹʬΥ˳Ǽʸ
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		ʬΥݤ롣
 *		
 *	
 *	string: ʸؤǻꤵ줿ʸΥԡ
 *	
 *	next_ptr: ؤΥ󥯨ĢؤΥ
 *	
 *	NULLݥ󥿡ʥ󥯤νü͡
 *	
 ***************************************************************************/
LineLink *lineAlloc(const char *string)
{
	LineLink *alloc_ptr = NULL;
	
	alloc_ptr = (LineLink*)_string_malloc(sizeof(LineLink));
	if(alloc_ptr != NULL) {
		if(string != NULL) {
			alloc_ptr->string = (char*)_string_newString(string);
		} else {
			alloc_ptr->string = NULL;
		}
		alloc_ptr->next_ptr = NULL;
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	lineFree: ʸѤΥ
 *	
 *		void lineFree(LineLink *lyric);
 *	֤
 *		LineLink *lyric;		ʸ󥯥ȥꥹȤΥ
 *	
 *		ʲΥޤ
 *		
 *	
 *	string: ʸؤǻꤵ줿ʸΥԡ
 *	
 *	next_ptr: ؤΥ󥯨ĢؤΥ
 *	
 *	NULLݥ󥿡ʥ󥯤νü͡
 *	
 ***************************************************************************/
void lineFree(LineLink *release_ptr)
{
	if(release_ptr != NULL) {
#ifdef	DEBUG
		printf("%s\n", release_ptr->string);
#endif	/*DEBUG*/
		_string_free(release_ptr->string);
		_string_free(release_ptr);
	}
}

/***************************************************************************
 *	linesRelease: ʸѤΥ
 *	
 *		void linesRelease(LineLink *lines);
 *	֤
 *		LineLink *lines;	ʸ󥯥ȥꥹȤΥ
 *	
 *		ꤵ줿󥯰ʹߤʸʹߤΥ롣
 *		
 *		ʸƬ
 *		
 *		ʸ󡡡
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		ʸ󡡡
 *		
 *		ؤΥ󥯨
 *		
 *		
 *		ʸ󡡡
 *		
 *		ؤΥ󥯨
 *		
 *		NULLݥ󥿡ʸ
 *		
 *		
 ***************************************************************************/
void linesRelease(LineLink *lines)
{
	LineLink *release_ptr;
	
	while(lines != NULL) {
		release_ptr = lines;
		lines = lines->next_ptr;
		lineFree(release_ptr);
	}
}

/***************************************************************************
 *	string2lines: ԰ʾΥݤ
 *	
 *		LineLink *string2lines(const char *string);
 *	
 *		const char *string;		ݤ룱԰ʾʸ
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		԰ʾΥݤ롣
 *		ԥɡ'\n'ˤǶڤƤ硢ʣԤݤ롣
 *		
 ***************************************************************************/
LineLink *string2lines(const char *string)
{
	int length;
	int loopExit = True;
	const char *line_ptr, *line_end_ptr;
	LineLink *alloc_ptr = NULL, *allocTop;

	line_ptr = string;
	allocTop = alloc_ptr = lineAlloc(NULL);
	do {
		loopExit = True;
		line_end_ptr = strchr(line_ptr, '\n');
		length = ((line_end_ptr != NULL)?
						(line_end_ptr-line_ptr+1):(strlen(line_ptr)));
		alloc_ptr->string = (char*)_string_malloc(length+1);
		if(alloc_ptr->string != NULL) {
			sprintf(alloc_ptr->string, "%.*s", length, line_ptr);
#ifdef	DEBUG
			printf("%s\n", alloc_ptr->string);	fflush(stdout);
#endif	/*DEBUG*/
			alloc_ptr->next_ptr = lineAlloc(NULL);
		}
		if(line_end_ptr != NULL && alloc_ptr->next_ptr != NULL) {
			line_ptr = line_end_ptr + (*line_end_ptr == '\n');
			alloc_ptr = alloc_ptr->next_ptr;
			loopExit = False;
		}
	} while(loopExit == False);
	_string_free(alloc_ptr->next_ptr);
	alloc_ptr->next_ptr = NULL;
	return(allocTop);
}

/***************************************************************************
 *	linesConnect: ʸ󥯤³
 *	
 *		LineLink *linesConnect(LineLink *lines1, LineLink *lines2);
 *	
 *		LineLink *lines1;	¦ʸ
 *		LineLink *lines2;	¦ʸ
 *	֤
 *		ʸ󥯤Ƭ
 *	
 *		
 ***************************************************************************/
LineLink *linesConnect(LineLink *lines1, LineLink *lines2)
{
	LineLink *lines_ptr;

	if(lines1 != NULL) {
		lines_ptr = lines1;
		while(lines_ptr->next_ptr != NULL) {
			lines_ptr = lines_ptr->next_ptr;
		}
		lines_ptr->next_ptr = lines2;
	} else {
		lines1 = lines2;
	}
	return(lines1);
}

/***************************************************************************
 *	linesLength: ʸ󥯥ȥꥹȤʸ򥫥Ȥ
 *	
 *		int linesLength(LineLink *strings);
 *	֤
 *		ʸ󥯥ȥꥹȤʸ
 *	
 *		
 ***************************************************************************/
int linesLength(LineLink *strings)
{
	int counter;
	
	counter = 0;
	while(strings != NULL) {
		counter += strlen(strings->string);
		strings = strings->next_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	lines2string: ʸ󥯤ʸѴ
 *	
 *		String lines2string(LineLink *strings);
 *	
 *		LineLink *strings;
 *	֤
 *		NULL:		顼ʥ­
 *		NULLʳ:	Ѵ줿ʸ
 *	
 *		
 ***************************************************************************/
String lines2string(LineLink *strings)
{
	int counter;
	size_t length;
	String textString;
	
	length = linesLength(strings);
	textString = _string_malloc(length + 1);
	for(counter = 0, *textString = '\0';strings != NULL && 
			counter+strlen(strings->string) <= length;
			counter+=strlen(strings->string), strings=strings->next_ptr) {
		strcat(textString, strings->string);
	}
	return(textString);
}

/***************************************************************************
 *	linesTextLength: ʸ󥯥ȥꥹȤʸ򥫥Ȥ
 *	
 *		int linesLength(LineLink *strings);
 *	֤
 *		ʸ󥯥ȥꥹȤʸ
 *	
 *		
 ***************************************************************************/
int linesTextLength(LineLink *strings)
{
	int counter;
	
	counter = 0;
	while(strings != NULL) {
		counter += strcspn(strings->string, "\n\r") + 1;
		strings = strings->next_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	lines4textString: ʸ󥯤ʸѴ
 *	
 *		String lines4textString(LineLink *strings);
 *	
 *		LineLink *strings;
 *	֤
 *		NULL:		顼ʥ­
 *		NULLʳ:	Ѵ줿ʸ
 *	
 *		
 ***************************************************************************/
String lines4textString(LineLink *strings)
{
	int counter;
	size_t length;
	String textString;
	
	length = linesTextLength(strings);
	textString = _string_malloc(length + 2);
	for(counter = 0, *textString = '\0';strings != NULL && 
		counter+(strcspn(strings->string,"\b\n\r")+1) <= length;
		counter+=(strcspn(strings->string,"\b\n\r")+1), strings=strings->next_ptr) {
		strcat(textString, strings->string);
		strcpy(textString+counter+strcspn(strings->string,"\b\n\r"), "\n");
	}
	return(textString);
}

/***************************************************************************
 *	file2lines: եɤ߹ߥݤ
 *	
 *		LineLink *file2lines(FILE *stream);
 *	
 *		FILE *stream;		ե롦ݥ
 *	֤
 *		NULL		­
 *		NULLʳ	Ƥ줿
 *	
 *		եʸ󥯡ݤ롣
 *		
 ***************************************************************************/
LineLink *file2lines(FILE *stream)
{
	char buffer[4096];
	const char *line;
	LineLink *alloc_ptr = NULL, allocTop;

	alloc_ptr = &allocTop;
	while(line = fgets(buffer, sizeof(buffer), stream), line != NULL) {
		line = (char*)alloc_ptr->next_ptr = lineAlloc(NULL);
		if(alloc_ptr->next_ptr != NULL) {
			alloc_ptr->next_ptr->string = _string_newString(buffer);
			if(alloc_ptr->next_ptr->string != NULL) {
				alloc_ptr = alloc_ptr->next_ptr;
			} else {
				break;
			}
		}
	}
	alloc_ptr->next_ptr = NULL;
	return(allocTop.next_ptr);
}

/***************************************************************************
 *	lines2file: եʸ󥯥ȥꥹȤ񤭽Ф
 *	
 *		void lines2file(const LineLink *lines, FILE *stream);
 *	
 *		const LineLink *lines;	ʸ󥯥ȥꥹ
 *		FILE *stream;			Υեݥ
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void lines2file(const LineLink *lines, FILE *stream)
{
	while(lines != NULL) {
		fputs(lines->string, stream);
		lines = lines->next_ptr;
	}
}

/***************************************************************************
 *	countLines: ʸ󥯥ȥꥹȤιԿ򥫥Ȥ
 *	
 *		int countLines(LineLink *strings);
 *	֤
 *		ʸ󥯥ȥꥹȤιԿ
 *	
 *		
 ***************************************************************************/
int countLines(LineLink *strings)
{
	int counter;
	
	counter = 0;
	while(strings != NULL) {
		++counter;
		strings = strings->next_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	lines2stringArray: ʸ󥯥ȥꥹȤʸ󲽤
 *	
 *		int lines2stringArray(LineLink *strings, 
 *							void (*convertString)(char *string));
 *	
 *		LineLink *strings;						ʸ󥯥ȥꥹ
 *		void (*convertString)(char *string);	ʸؿ
 *	֤
 *		ʸؤΥݥ
 *	
 *		ʸ󥯥ȥꥹȤʸ󲽤롣
 *		κݡˤʤ륭饯 convertString() ǽ뤳Ȥ
 *		Ǥ롣ʼˤʤ륭饯Ȥϡ\r,\n Ǥ롣
 ***************************************************************************/
char **lines2stringArray(LineLink *strings, void (*convertString)(char *string))
{
	int arrays, counter;
	char **string_ptr_ptr;
	
	arrays = countLines(strings);
	++arrays;
	string_ptr_ptr = (char**)_string_malloc(sizeof(*string_ptr_ptr) * arrays);
	if(string_ptr_ptr != NULL) {
		memset(string_ptr_ptr, 0x00, sizeof(*string_ptr_ptr) * arrays);
		counter = 0;
		while(strings != NULL) {
			if(convertString != NULL) {
				convertString(strings->string);
			}
			*(string_ptr_ptr+counter) = strings->string;
			++counter;
			strings = strings->next_ptr;
		}
	}
	return(string_ptr_ptr);
}

/***************************************************************************
 *	arrayCount: NULL üݥθĿ
 *	
 *		int arrayCount(XtPointer *pointerArray);
 *	
 *		XtPointer *pointerArray;	ݥؤݥ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int arrayCount(XtPointer *pointerArray)
{
	int counter;

	counter = 0;
	while(*(pointerArray+counter) != NULL) {
		++counter;
	}
	return(counter);
}

/***************************************************************************
 *	nullTerminatedPointerArrayFree: NULLݥ󥿤ǽݥ
 *	
 *		void nullTerminatedPointerArrayFree(void **pointerArray);
 *	
 *		void **pointerArray;
 *	֤
 *		
 *	
 *		NULLݥ󥿤ǽݥޤ
 *		ܤϡʲΥǡΥݥؤޤ
 *		
 *		
 *		pointerArrayġݥѤ˳Ƥ줿ΰؤ
 *		
 *		
 *		ΰ衡
 *		
 *		
 *		źΥݥ󥿨źΥݥ󥿤ؤʼΡˢ
 *		
 *		źΥݥ󥿨źΥݥ󥿤ؤʼΡˢ
 *		
 *		ġ
 *		
 *		źΥݥ󥿨źΥݥ󥿤ؤʼΡˢ
 *		
 *		ġ
 *		
 *		 ǸΥݥ NULL ݥ
 *		
 *		
 *		ϡNULL ݥ󥿤ǽݥκǽ餫Ǹ
 *		Υݥ󥿤ޤǤΤ٤ƤΥݥ󥿤ؤȡݥ󤽤Τ
 *		Τ롣
 *		ʸιǤ⤳Τ褦ʷϤޤξϡδؿ
 *		ѤǤޤ
 *	Х
 *		δؿǤϡ_string_free() ǥޤ
 *		δؿϡºݤˤϡץˤä XtFree()/free() Τɤ
 *		δؿǥޤ
 *		ΤᡢƤ malloc() or XtMalloc()/XtNewString() 
 *		Τɤǳݤ줿Τ碌ɬפޤ
 *		
 *		 ѥ ؿ㡡
 *		
 *		 ANSI _XtIntrinsic_h̤malloc()/realoc()/free()
 *		
 *		X11 _XtIntrinsic_h  XtMalloc()/XtNewString()/XtFree() 
 *		
 *		
 *		ŪˤϡX11ɸ XtMalloc() ѤƤޤΤǡANSI C ɸ 
 *		malloc() 䤽¾ΥƴؿǤʤȤǧƲ
 *		
 *		ƱͤˡʬΰˤǤ XtMalloc() Υ
 *		̵Τ¸ߤϡХˤʤޤ
 *		ޤݥϡNULL ݥ󥿤ǽλȸ郎ޤΤǡ
 *		 NULL ݥ󥿤äФԽʬˤʤ
 *		ޤ
 ***************************************************************************/
void nullTerminatedPointerArrayFree(void **pointerArray)
{
	int counter;

	if(pointerArray != NULL) {
		for(counter = 0;*(pointerArray+counter) != NULL;++counter) {
			_string_free(*(pointerArray + counter));
		}
		_string_free((char*)pointerArray);
	}
}

/***************************************************************************
 *	searchInStringArray: ʸ椫ꤵ줿ʸȰפ뤫õ
 *	
 *		int searchInStringArray(const char *target, 
 *					int limit, const char **names, 
 *					int (*compare)(const char *s1, const char *s2));
 *	
 *		const char *target;		ʸ
 *		int limit;				оݤĿ
 *		const char **names;		ʸ
 *		int (*compare)(const char *s1, const char *s2);
 *								ˡNULL ȡstrcmp() Ȥ
 *	֤
 *		EOF:		줿ʸ󤬸Ĥʤä
 *		ʾ塧	줿ʸȰפźʤֹ
 *	
 *		
 ***************************************************************************/
int searchInStringArray(const char *target, int limit, const char **names, 
							int (*compare)(const char *s1, const char *s2))
{
	int counter;

	if(compare == NULL) {
		compare = strcmp;
	}
	for(counter = 0;counter < limit;++counter) {
		if(compare(*(names + counter), target) == 0) {
			return(counter);
		}
	}
	return(EOF);
}

/***************************************************************************
 *	searchInStringPointerArray: ʸؤΥݥ󤫤ʸ󸡺
 *	
 *		int searchInStringPointerArray(const char *target, const char **names, 
 *							int (*compare)(const char *s1, const char *s2));
 *	
 *		const char *target;		ʸ
 *		const char **names;		ʸؤΥݥNULLü
 *		int (*compare)(const char *s1, const char *s2);
 *								ˡNULL ȡstrcmp() Ȥ
 *	֤
 *		EOF:		줿ʸ󤬸Ĥʤä
 *		ʾ塧	줿ʸȰפźʤֹ
 *	
 *		
 ***************************************************************************/
int searchInStringPointerArray(const char *target, const char **names, 
							int (*compare)(const char *s1, const char *s2))
{
	int counter;

	if(compare == NULL) {
		compare = strcmp;
	}
	for(counter = 0;*(names + counter) != NULL;++counter) {
		if(compare(*(names + counter), target) == 0) {
			return(counter);
		}
	}
	return(EOF);
}

/***************************************************************************
 *	VCreatePointorsLink: ѰʣĤΥݥѿޤȤ
 *	
 *		int VCreatePointorsLink(PointorsLink **linkBuffer, va_list argument)
 *	
 *		PointorsLink **linkBuffer;	󥯥ꥹȲ줿Ѱʬ֤
 *		va_list argument;			ꥹȲѰʬNULLǽ
 *	֤
 *		ݥѿ
 *	
 *		ѰͿ줿ĤΥݥѿ󥯤ǤޤȤޤ
 *		
 *		
 * 			int argcount;
 *			va_list argument;
 *			PointorsLink linkBuffer;
 *			
 *			argcount = VCreatePointorsLink(&linkBuffer, argument);
 *		
 *	Ȼ
 *		VaCreatePointorsLink();		ѰʣĤΥݥѿޤȤ
 *		VaDestroyPointorsLink();	ѥݥ󥿥󥯤˴
 *		cutoffPointorsLink();		ѥݥ󥿥󥯤ǡФ
 *		
 *		PointorsLink ΥǡդƤϡstringuty.h 򻲾
 *		
 *	Хջ
 *		ѰǤݥ󥿤ϤȤ뤬ͤΥݥ
 *		NULLݥ󥿡ˤϡǡȤƼ̤뤿ϤȤ
 *		ʤݥѿμΤϤȤˤϡNULLˤʤʤȤǧ
 *		ƤʤȥХˤʤΤդɬס
 *		ݥ󥿤ϤȤˤϡΤΥ꤬Ϥ줿Ȥ¸ߤƤ
 *		Хˤʤޤ
 *		
 ***************************************************************************/
int VCreatePointorsLink(PointorsLink **linkBuffer, va_list argument)
{
	int argc;						/* ѰʬθĿ */
	void *argv;						/* Фݥ */
	PointorsLink *topList = NULL;	/* 󥯥ȥꥹȲݥ󥿤Ƭ */
	PointorsLink *previousLink = NULL;	/* ߤޤǤΥꥹȤؤ */
	PointorsLink *currentLink = NULL;	/* ꥹȤ³󥯥ݥ */

	argc = 0;				/* ʬθĿν */
	argv = &argv;			/* NULLʳǽɬפ뤿 */

	while(argv != NULL) {
		/*  */
		argv = va_arg(argument, void*);		/* ѰμФ */

		if(argv != NULL) {
			/* Ѱ³ʤ */
			++argc;
			currentLink = (PointorsLink*)XtMalloc(sizeof(PointorsLink));
			currentLink->data_ptr = argv;			/* ꥹȤϿ */
			currentLink->type_pointer = NULL;		/* Хåեʤ */
			currentLink->bufferSize = 0;			/* Хåեʤ */
			currentLink->prevLink = previousLink;	/* ؤΥ󥯤³ */
			currentLink->nextLink = NULL;			/* ؤΥ󥯤 */
			currentLink->typeName[0] = '\0';		/* ̾ʤʤ */
			if(currentLink->prevLink != NULL) {
				/***********************************************************
				 *	󥯤Ƭʳʤľμ򸽺ߤΥݥ󥿤³
				 ***********************************************************/
				currentLink->prevLink->nextLink = currentLink;
			} else {
				topList = currentLink;	/* ꥹȤƬؤΥݥ󥿤 */
			}
		}
		/*  */
		previousLink = currentLink;		/* ľΥݥ󥿤򹹿 */
	}
	if(topList != NULL) {
		/* ѰʬäȤ */
		*linkBuffer = topList;
	}

	return(argc);
}

/***************************************************************************
 *	VaCreatePointorsLink: ѰʣĤΥݥѿޤȤ
 *	
 *		int VaCreatePointorsLink(PointorsLink **linkBuffer, ...);
 *	
 *		PointorsLink **linkBuffer;	󥯥ꥹȲ줿Ѱʬ֤
 *		...							ꥹȲѰʬNULLǽ
 *	֤
 *		ݥѿ
 *	
 *		ѰͿ줿ĤΥݥѿ󥯤ǤޤȤޤ
 *		
 *		
 * 			int argcount;
 *			PointorsLink linkBuffer;
 *			
 *			argcount = VaCreatePointorsLink(&linkBuffer, 
 *									pointer1, pointer2, poitner3, NULL);
 *		
 *	Ȼ
 *		VaDestroyPointorsLink();	ѥݥ󥿥󥯤˴
 *		cutoffPointorsLink();		ѥݥ󥿥󥯤ǡФ
 *		
 *		PointorsLink ΥǡդƤϡstringuty.h 򻲾
 *		
 *	Хջ
 *		ѰǤݥ󥿤ϤȤ뤬ͤΥݥ
 *		NULLݥ󥿡ˤϡǡȤƼ̤뤿ϤȤ
 *		ʤݥѿμΤϤȤˤϡNULLˤʤʤȤǧ
 *		ƤʤȥХˤʤΤդɬס
 *		ݥ󥿤ϤȤˤϡΤΥ꤬Ϥ줿Ȥ¸ߤƤ
 *		Хˤʤޤ
 *		
 ***************************************************************************/
int VaCreatePointorsLink(PointorsLink **linkBuffer, ...)
{
	int argc;
	va_list argument;

	va_start(argument, linkBuffer);		/* ѰΤ */
	argc = VCreatePointorsLink(linkBuffer, argument);
	va_end(argument);					/* Ѱ˴ؤ */

	return(argc);
}

/***************************************************************************
 *	VaGetPointorsLink: ݥ󥿥󥯤ѿФ
 *	
 *		int VaGetPointorsLink(const PointorsLink *linkBuffer, ...);
 *	
 *		const PointorsLink *linkBuffer;	󥯥ꥹȲ줿ݥ󥿷
 *		...				ݥ󥿤뤿βѰʬNULLǽ
 *	֤
 *		Ǥݥѿ
 *	
 *		
 ***************************************************************************/
int VaGetPointorsLink(const PointorsLink *linkBuffer, ...)
{
	int argc;					/* ѰʬθĿ */
	void **argv_ptr;			/* Фݥ */
	va_list argument;
	const PointorsLink *currentLink = linkBuffer;	/* 󥯥ݥ */

	va_start(argument, linkBuffer);		/* ѰΤ */

	argc = 0;						/* ʬθĿν */
	argv_ptr = (void**)&argv_ptr;	/* NULLʳǽɬפ뤿 */
	
	while(linkBuffer != NULL && argv_ptr != NULL) {
		/*  */
		argv_ptr = va_arg(argument, void**);	/* ѰμФ */

		if(argv_ptr != NULL) {
			/* Ѱ³ʤ */
			++argc;
			*argv_ptr   = currentLink->data_ptr;
			currentLink = currentLink->nextLink;
		}
	}
	va_end(argument);					/* Ѱ˴ؤ */

	return(argc);
}

/***************************************************************************
 *	ValuesLinkAlloc: ѿ󥯤ͤݤ
 *	
 *		PointorsLink *ValuesLinkAlloc(size_t size, void *value, const char *type);
 *	
 *		size_t size;		ѿХåեؤΥ
 *		void *value;		ѿХåեؤؤݥ
 *		const char *type;	ѿηʸ󡧥ǥХåѡ
 *	֤
 *		NULLʳ:		ݤѿΥХåեؤݥ
 *	
 *		
 *		
 *		򼨤ʸ
 *			XtRInt/XtRPointer/XtRString/XtRImmediate ѿ򼨤
 *			Ѥ߼̻ҤȽѤǤդʸѤǤޤ
 *			ʤXtRImmediate ̤ʰ̣äƤϤޤ󡣤
 *			åɬʤݥ󥿤ΥʲΥǡǡ
 *			쥯Ȥͤ¸ɤˤϡXtRImmediate Ѥ
 *			ʬˣꤷƲ
 *			ʤåɬפʤϡ"" Ѥ뤳ȤǤޤ
 *			Ĥޤ "" ѿȤꤷϡФΤȤ˹Ԥ
 *			åάޤ
 *		
 *		orͤΥݥϤ
 *			ʬˣꤷʤϡͤݥϤˤʤäƤ
 *			ȽǤޤξϡͤľϤȤ򼨤ޤ
 *			
 *		
 *			Хåեݤ¸륵򼨤ޤݥ󥿤
 *			ǤȤϡ򣰤ˤ롣
 *			ʤEOF ˤϡʸ󷿤Ȥߤʤơstrlen() Ѥ
 *			ơ0x00 ΥХȤޤǤХȿ᤽ΥХåեݤ롣
 *		
 *			ǡХåեʤξ
 *				
 *				 NULL or 
 *				ǡΤب
 *				ǡ
 *				 ̾ؤ 
 *				
 *				 ХåեĹ 
 *				
 *				ؤΥ󥯨 NULL 
 *				
 *				ؤΥ󥯨 NULL 
 *				
 *				̾Хåե
 *				
 *				
 *				ǡХåեʤξϡإǡΤؤݥ󥿡
 *				Τݥ󥿤ϤΤ intʤɤѿѤ
 *				Ѥޤ
 *			
 *			ǡХåեξ
 *				
 *				
 *				ǡΤب
 *				
 *				 ̾ؤ 
 *				
 *				 ХåեĹ 
 *				
 *				ؤΥ󥯨 NULL 
 *				
 *				ؤΥ󥯨 NULL 
 *				
 *				̾Хåե
 *				
 *				Хåե
 *				
 *				
 *			ǡХåեξϡإǡΤؤݥ󥿡٤̾
 *			ХåեľꤷΥǡ򤳤ΰ֤˥ԡޤ
 *			ǡХåեʤξӤȤ;ʬʥ
 *			뤳Ȥˤʤޤ
 *		
 *		1998/7/15 ɲá̤ƥ, 7/16 ѹ
 *
 *	ǡ¤
 *		ǡ¤ΤƬ
 *		 NULL or 
 *		ǡΤب
 *		ǡ
 *		 ̾ؤ  NULL 
 *		
 *		 ХåեĹ 
 *		
 *		ؤΥ󥯨 NULL 
 *		
 *		ؤΥ󥯨
 *		
 *		̾Хåե
 *		
 *		Хåե
 *		
 *		
 *		
 *		 NULL or 
 *		
 ***************************************************************************/
PointorsLink *ValuesLinkAlloc(size_t size, void *value, const char *type)
{
	size_t bufferSize;
	PointorsLink *alloc_ptr;
	
	/* Ѱ³ʤ */
	if(size == EOF) {
		size = strlen(value) + 1;
	}
	bufferSize = sizeof(PointorsLink) + strlen(type);
	if(size > 0) {
		bufferSize += size;
	}
	alloc_ptr = (PointorsLink*)XtMalloc(bufferSize);
	strcpy(alloc_ptr->typeName, type);
	alloc_ptr->type_pointer = alloc_ptr->typeName;
	if(size > 0) {
		/***********************
		 *	ХåեĤξ
		 ***********************/
		alloc_ptr->bufferSize = size;
		alloc_ptr->data_ptr = 
				(void*)(alloc_ptr->typeName + strlen(type) + 1);
		memcpy(alloc_ptr->data_ptr, value, size);
	} else {
		/***********************
		 *	Хåեʤξ
		 ***********************/
		alloc_ptr->data_ptr = value;	/* ꥹȤϿ */
		/*alloc_ptr->type_pointer = NULL;*/	/* Хåեʤ */
		alloc_ptr->bufferSize = 0;
	}
	alloc_ptr->prevLink = NULL;		/* ؤΥ󥯤 */
	alloc_ptr->nextLink = NULL;		/* ؤΥ󥯤 */
	return(alloc_ptr);
}

/***************************************************************************
 *	connectValuesLink: ѥݥ󥿥ѿ³
 *	
 *		void connectValuesLink(PointorsLink *insTarget, 
 *							PointorsLink *previous, PointorsLink *next);
 *	
 *		PointorsLink *insTarget;	оݤѥݥ󥿥󥯤ؤ
 *									оݤ̵ϡNULL
 *		PointorsLink *previous;		ľѥݥ󥿥󥯤ؤ
 *									ƬˤϡNULL
 *		PointorsLink *next;			ľѥݥ󥿥󥯤ؤ
 *									ˤϡNULL
 *	֤
 *		ʤ
 *	
 *		ѥݥ󥿥󥯤³Խޤ
 *		ŪˤϡʲΣĤεǽ롣
 *		1. previous  next δ֤ insTarget 롣
 *			connectValuesLink(insTarget, previous, next);
 *		2. previous  next ³롣
 *			connectValuesLink(NULL, previous, next);
 *		3. insTarget ƬȤ next ʸ³롣
 *			connectValuesLink(insTarget, NULL, next);
 *		4. insTarget Ȥ previous ³롣
 *			connectValuesLink(insTarget, previous, NULL);
 *		
 *		ʲΤ褦˻ꤷưϡͤȤޤ
 *		  connectValuesLink(NULL, previous, NULL); 
 *		  connectValuesLink(NULL, NULL, next); 
 *		
 *		̤ǤʲΤ褦ʵư򤷤ޤ
 *		  cconnectValuesLink(NULL, previous, NULL); Ǥϡprevious 
 *		ˤʤޤ
 *		  cconnectValuesLink(NULL, NULL, next); Ǥϡbext Ƭ
 *		ʤޤ
 *		
 ***************************************************************************/
void connectValuesLink(PointorsLink *insTarget, PointorsLink *previous, PointorsLink *next)
{
	if(insTarget != NULL) {
		insTarget->prevLink = previous;	/* ؤΥ󥯤³ */
		insTarget->nextLink = next;		/* ؤΥ󥯤³ */
	} else {
		insTarget = next;
		if(insTarget != NULL) {
			insTarget->prevLink = previous;	/* ؤΥ󥯤³ */
		}
		next = NULL;
	}
	if(previous != NULL) {
		/***********************************************************
		 *	󥯤Ƭʳʤľμ򸽺ߤΥݥ󥿤³
		 ***********************************************************/
		previous->nextLink = insTarget;
	}
	if(next != NULL) {
		/***********************************************************
		 *	󥯤Ƭʳʤľμ򸽺ߤΥݥ󥿤³
		 ***********************************************************/
		next->prevLink = insTarget;
	}
}

/***************************************************************************
 *	VCreateValuesLink: ѰʣĤΥݥѿޤȤ
 *	
 *		int VCreateValuesLink(PointorsLink **linkBuffer, va_list argument)
 *	
 *		PointorsLink **linkBuffer;	󥯥ꥹȲ줿Ѱʬ֤
 *		va_list argument;			ꥹȲѰʬNULLǽ
 *	֤
 *		ݥѿ
 *	
 *		ѰͿ줿ĤΥݥѿ󥯤ǤޤȤޤ
 *		
 *		
 * 			int argcount;
 *			va_list argument;
 *			PointorsLink linkBuffer;
 *			
 *			argcount = VCreateValuesLink(&linkBuffer, argument);
 *		
 *	Ȼ
 *		VaCreatePointorsLink();		ѰʣĤΥݥѿޤȤ
 *		VaDestroyPointorsLink();	ѥݥ󥿥󥯤˴
 *		cutoffPointorsLink();		ѥݥ󥿥󥯤ǡФ
 *		
 *		PointorsLink ΥǡդƤϡstringuty.h 򻲾
 *		
 *	Хջ
 *		ݥ󥿤ϤȤˤϡΤΥ꤬Ϥ줿Ȥ¸ߤƤ
 *		Хˤʤޤ
 *		
 ***************************************************************************/
int VCreateValuesLink(PointorsLink **linkBuffer, va_list argument)
{
	int argc;					/* ѰʬθĿ */
	size_t argSize;				/* ΥХåե */
	void *argValue;				/* ; */
	const char *argType;		/*  */
	PointorsLink *topList = NULL;	/* 󥯥ȥꥹȲݥ󥿤Ƭ */
	PointorsLink *previousLink = NULL;	/* ߤޤǤΥꥹȤؤ */
	PointorsLink *currentLink = NULL;	/* ꥹȤ³󥯥ݥ */

	argc = 0;							/* ʬθĿν */
	argType = (const char*)&argType;	/* NULLʳǽɬפ뤿 */

	while(argType != NULL) {
		/*  */
		argType = va_arg(argument, const char*);	/* ѰμФ */

		if(argType != NULL) {
			/* Ѱ³ʤ */
			++argc;
			argValue = va_arg(argument, void*);		/* ѰμФ */
			argSize  = va_arg(argument, size_t);	/* μФ */
#ifndef	OLD_IMPLEMENT
			currentLink = ValuesLinkAlloc(argSize, argValue, argType);
			connectValuesLink(currentLink, previousLink, NULL);
			if(topList == NULL) {
				topList = currentLink;	/* ꥹȤƬؤΥݥ󥿤 */
			}
#else
			if(argSize == EOF) {
				argSize = strlen(argValue) + 1;
			}
			bufferSize = sizeof(PointorsLink) + strlen(argType);
			if(argSize > 0) {
				bufferSize += argSize;
			}
			currentLink = (PointorsLink*)XtMalloc(bufferSize);
			strcpy(currentLink->typeName, argType);
			currentLink->type_pointer = currentLink->typeName;
			if(argSize > 0) {
				/***********************
				 *	ХåեĤξ
				 ***********************/
				currentLink->bufferSize = argSize;
				currentLink->data_ptr = 
						(void*)(currentLink->typeName + strlen(argType) + 1);
				memcpy(currentLink->data_ptr, argValue, argSize);
			} else {
				/***********************
				 *	Хåեʤξ
				 ***********************/
				currentLink->data_ptr = argValue;	/* ꥹȤϿ */
				currentLink->type_pointer = NULL;	/* Хåեʤ */
				currentLink->bufferSize = 0;
			}
			currentLink->prevLink = previousLink;	/* ؤΥ󥯤³ */
			currentLink->nextLink = NULL;			/* ؤΥ󥯤 */
			if(currentLink->prevLink != NULL) {
				/***********************************************************
				 *	󥯤Ƭʳʤľμ򸽺ߤΥݥ󥿤³
				 ***********************************************************/
				currentLink->prevLink->nextLink = currentLink;
			} else {
				topList = currentLink;	/* ꥹȤƬؤΥݥ󥿤 */
			}
#endif	/*OLD_IMPLEMENT*/
		}
		/*  */
		previousLink = currentLink;		/* ľΥݥ󥿤򹹿 */
	}
	if(topList != NULL) {
		/* ѰʬäȤ */
		*linkBuffer = topList;
	}

	return(argc);
}

/***************************************************************************
 *	VaCreateValuesLink: ѰʣĤΥݥѿޤȤ
 *	
 *		int VaCreateValuesLink(PointorsLink **linkBuffer, ...);
 *	
 *		PointorsLink **linkBuffer;	󥯥ꥹȲ줿Ѱʬ֤
 *		...							ꥹȲѰʬNULLǽ
 *	֤
 *		ݥѿ
 *	
 *		ѰͿ줿ĤΥݥѿ󥯤ǤޤȤޤ
 *		ΰʬϡ򼨤ʸorͤΥݥϤ
 *		ǤƤޤ
 *		
 *		򼨤ʸ
 *			XtRInt/XtRPointer/XtRString/XtRImmediate ѿ򼨤
 *			Ѥ߼̻ҤȽѤǤդʸѤǤޤ
 *			ʤXtRImmediate ̤ʰ̣äƤϤޤ󡣤
 *			åɬʤݥ󥿤ΥʲΥǡǡ
 *			쥯Ȥͤ¸ɤˤϡXtRImmediate Ѥ
 *			ʬˣꤷƲ
 *			ʤåɬפʤϡ"" Ѥ뤳ȤǤޤ
 *			Ĥޤ "" ѿȤꤷϡФΤȤ˹Ԥ
 *			åάޤ
 *		
 *		orͤΥݥϤ
 *			ʬˣꤷʤϡͤݥϤˤʤäƤ
 *			ȽǤޤξϡͤľϤȤ򼨤ޤ
 *			
 *		
 *			Хåեݤ¸륵򼨤ޤݥ󥿤
 *			ǤȤϡ򣰤ˤ롣
 *			ʤEOF ˤϡʸ󷿤Ȥߤʤơstrlen() Ѥ
 *			ơ0x00 ΥХȤޤǤХȿ᤽ΥХåեݤ롣
 *		
 *		ǡХåեʤξ
 *			
 *			 NULL or 
 *			ǡΤب
 *			ǡ
 *			 ̾ؤ  NULL 
 *			
 *			 ХåեĹ 
 *			
 *			ؤΥ󥯨 NULL 
 *			
 *			ؤΥ󥯨
 *			
 *			̾Хåե
 *			
 *			
 *			ǡХåեʤξϡإǡΤؤݥ󥿡ټΤ
 *			ݥ󥿤ϤΤ intʤɤѿѤˤѤޤ
 *			
 *		ǡХåեξ
 *			
 *			
 *			ǡΤب
 *			
 *			 ̾ؤ  NULL 
 *			
 *			 ХåեĹ 
 *			
 *			ؤΥ󥯨 NULL 
 *			
 *			ؤΥ󥯨
 *			
 *			̾Хåե
 *			
 *			Хåե
 *			
 *			
 *			ǡХåեξϡإǡΤؤݥ󥿡٤̾
 *			ХåեľꤷΥǡ򤳤ΰ֤˥ԡޤ
 *			ǡХåեʤξӤȤ;ʬʥ
 *			뤳Ȥˤʤޤ
 *		
 *		
 *			#define UserDefiniton "UserDefiniton"
 *			typedef ... UserDefiniton
 *			
 * 			int argcount;
 *			int integerValue = 123;
 *			void *pinter1, *pointer2;
 *			UserDefiniton data;
 *			PointorsLink *linkBuffer;
 *			
 *			argcount = VaCreateValuesLink(&linkBuffer, 
 *							XtRInt,	&integerValue, 4, 	ġ
 *			
 *			argcount = VaCreateValuesLink(&linkBuffer, 
 *							XtRInt,	&integerValue, 4, 	ġ
 *							XtRPointer, pointer2, 4, 	ġݥ󥿣
 *							XtRPointer, pointer2, 0, 	ġݥ󥿣
 *							XtRString, "string", EOF,	ġʸ
 *							XtRImmediate, 1234, 0, 		ġͤ쥯
 *							UserDefiniton, data, 
 *								sizeof(UserDefiniton), 	ġ桼 
 *							NULL);						ġλ
 *		
 *		ºݤλѤˤĤ
 *		  Ϥ
 *			μϤǤϡ嵭ˡޤʣͤޤ
 *				XtRInt,	&integerValue, 4,	ġХåեѥݥϤ
 *				XtRInt,	123, 4, 			ġХåեʤǥ쥯
 *				XtRImmediate, 1234, 0, 		ġͤ쥯
 *				"int", 1234, 0, 			ġͤ쥯
 *				"int",	&integerValue, 4,	ġХåեѥݥϤ
 *				"", 1234, 0, 				ġͤ쥯ȡʷȽʤ
 *			
 *		  ʸϤ
 *			ʸμϤǤ⡢嵭ˡޤʣͤޤ
 *				XtRString, "string", EOF,	ġХåեѡʸ
 *				XtRString, string_ptr, 0,	ġХåեʤǥ쥯
 *				XtRImmediate, "string", 0, 	ġͤ쥯
 *				"char*", string_ptr, 0,		ġʸ
 *				"", string_ptr, 0,			ġʸʷȽʤ
 *		
 *			ηδؿǤΰηåϡط򼨤ʸ٤ǹԤ
 *			ޤΤᡢXtRString ¸줿ǡФȤ 
 *			"char*" Ѥȥ顼ˤʤޤ
 *			"char*"  "char *" ζʸ㤤Ǥ⥨顼ˤʤޤ
 *	Ȼ
 *		VaDestroyPointorsLink();	ѥݥ󥿥󥯤˴
 *		cutoffPointorsLink();		ѥݥ󥿥󥯤ǡФ
 *		
 *		PointorsLink ΥǡդƤϡstringuty.h 򻲾
 *		
 *	Хջ
 *		ѰǤݥ󥿤ϤȤ뤬ͤΥݥ
 *		NULLݥ󥿡ˤϡǡȤƼ̤뤿ϤȤ
 *		ʤݥѿμΤϤȤˤϡNULLˤʤʤȤǧ
 *		ƤʤȥХˤʤΤդɬס
 *		ݥ󥿤ϤȤˤϡΤΥ꤬Ϥ줿Ȥ¸ߤƤ
 *		Хˤʤޤ
 *		
 ***************************************************************************/
int VaCreateValuesLink(PointorsLink **linkBuffer, ...)
{
	int argc;
	va_list argument;

	va_start(argument, linkBuffer);		/* ѰΤ */
	argc = VCreateValuesLink(linkBuffer, argument);
	va_end(argument);					/* Ѱ˴ؤ */

	return(argc);
}

/***************************************************************************
 *	terminalSearch: ˤäƽüõ
 *	
 *		const void *terminalSearch(const void *client_data, 
 *						const void *(nextStep)(const void *pointer));
 *	
 *		const void *client_data;
 *		const void *(*nextStep)(const void *pointer);
 *	֤
 *		NULL:		ü򸫤Ĥ뤳Ȥʤä
 *		NULLʳ:	Ĥüؤݥ
 *	
 *		
 *		
 ***************************************************************************/
const void *terminalSearch(const void *client_data, 
							const void *(*nextStep)(const void *pointer))
{
	const void *result_ptr = NULL;
	const void *next_ptr = client_data;

	while(next_ptr != NULL) {
		result_ptr = next_ptr;
		next_ptr = nextStep(next_ptr);
	}
	return(result_ptr);
}

/***************************************************************************
 *	terminalCount: üޤǤΥ󥯿򥫥Ȥ
 *	
 *		int terminalCount(const void *client_data, 
 *							const void *(*nextStep)(const void *pointer));
 *	
 *		const void *client_data;			󥯥ꥹȡʼʻȹ¤Ρ
 *		const void *(*nextStep)(const void *pointer);
 *											ؤΥ
 *	֤
 *		EOF:		NULL Ϥ줿ᥫȤǤʤä
 *		0ʾ:		üޤǤΥ󥯿
 *	
 *		
 ***************************************************************************/
int terminalCount(const void *client_data, 
							const void *(*nextStep)(const void *pointer))
{
	int counter;
	const void *next_ptr = client_data;

	if(client_data == NULL) {
		return(EOF);
	}
	for(counter = 0, next_ptr = nextStep(next_ptr);
				next_ptr != NULL;++counter, next_ptr = nextStep(next_ptr))
		;	/* ȤΤŪΤᡢ⤷ʤ */
	return(counter);
}

/***************************************************************************
 *	numSearch: ܤꤷƥݥ󥿤򥵡
 *	
 *		const void *numSearch(const void *client_data, 
 *					int no, const void *(*nextStep)(const void *pointer));
 *	
 *		const void *client_data;	оݤμʻȹ¤Τؤ
 *		int no;						оֹ
 *		const void *(*nextStep)(const void *pointer);	롼
 *	֤
 *		NULL:		Ĥʤä
 *		NULLʳ:	
 *	
 *		
 ***************************************************************************/
const void *numSearch(const void *client_data, 
					int no, const void *(*nextStep)(const void *pointer))
{
	int counter;
	const void *current_ptr = client_data;

	for(counter = 0;counter < no && current_ptr != NULL;++counter) {
		current_ptr = nextStep(current_ptr);
	}
	return(current_ptr);
}

/***************************************************************************
 *	prevPointersLink: PointorsLink ľΥ󥯤ؤ
 *	
 *		const void *prevPointersLink(const void *pointer);
 *	
 *		const void *pointer;
 *	֤
 *		NULL:		˽üãƤ뤫顼
 *		NULLʳ:	ľؤݥ
 *	
 *		
 ***************************************************************************/
const void *prevPointersLink(const void *pointer)
{
	PointorsLink *current = (PointorsLink*)pointer;

	return((const void*)current->prevLink);
}

/***************************************************************************
 *	nextPointersLink: PointorsLink ľΥ󥯤ؤ
 *	
 *		const void *nextPointersLink(const void *pointer);
 *	
 *		const void *pointer;
 *	֤
 *		NULL:		˽üãƤ뤫顼
 *		NULLʳ:	ľؤݥ
 *	
 *		
 ***************************************************************************/
const void *nextPointersLink(const void *pointer)
{
	PointorsLink *current = (PointorsLink*)pointer;

	return((const void*)current->nextLink);
}

/***************************************************************************
 *	VaAddValuesLink: ѰʣĤΥݥѿ󥯥ꥹȤɲä
 *	
 *		int VaAddValuesLink(PointorsLink **linkTop, ...);
 *	
 *		PointorsLink **linkTop;		ɲоݤΥݥ󥿥
 *		...							ɲäѰʬNULLǽ
 *	֤
 *		ɲäݥѿθĿ
 *	
 *		¸Υݥ󥿥󥯤أĤޤϡʣĤΥݥѿɲä롣
 *		ŪʻȤϡVaCreateValuesLink(); Ʊ*linkTop = NULL 
 *		ȤϡVaCreateValuesLink(); Ʊˤʤ롣
 *		
 ***************************************************************************/
int VaAddValuesLink(PointorsLink **linkTop, ...)
{
	int argc;
	va_list argument;
	PointorsLink *linkLast;
	PointorsLink *linkBuffer;

	va_start(argument, linkTop);		/* ѰΤ */
	argc = VCreateValuesLink(&linkBuffer, argument);
	va_end(argument);					/* Ѱ˴ؤ */
	if(linkTop == NULL) {
		*linkTop = linkBuffer;
	} else {
		linkLast = (PointorsLink*)terminalSearch(*linkTop, nextPointersLink);
		connectValuesLink(NULL, linkLast, linkBuffer);
	}

	return(argc);
}

/***************************************************************************
 *	*getValuesLink: ݥ󥿥󥯤ͤФ
 *	
 *		void *getValuesLink(size_t argSize, void *argValue, 
 * 					const char *argType, const PointorsLink *currentLink);
 *	
 *		size_t argSize;						Υ
 *		void *argValue;						ͤХåեؤΥݥ
 *		const char *argType;				̾ؤΥݥ
 *		const PointorsLink *currentLink;	ͤФХåե
 *	֤
 *		äХåեؤΥݥ
 *	
 *		
 ***************************************************************************/
void *getValuesLink(size_t argSize, void *argValue, 
					const char *argType, const PointorsLink *currentLink)
{
	switch(argSize) {
	case EOF:	/* ͤݤƼ */
		argValue = XtMalloc(currentLink->bufferSize);
		memcpy(argValue, currentLink->data_ptr, currentLink->bufferSize);
		break;
	case 0:		/* ݥ󥿤 */
		argValue = currentLink->data_ptr;
		break;
	default:	/* ݤ줿Хåեʬʤͤ */
		if(argSize > 0 && currentLink->bufferSize <= argSize) {
			argSize = currentLink->bufferSize;
			memcpy(argValue, currentLink->data_ptr, argSize);
		} else {
			fprintf(stderr, "getValuesLink(); : Fatal Error.\n");
		}
		break;
	}
	return(argValue);
}

/***************************************************************************
 *	VGetValuesLink: ޤȤƤѿѰηʣļФ
 *	
 *		int VGetValuesLink(const PointorsLink *linkBuffer, va_list argument);
 *	
 *		const PointorsLink *linkBuffer;	ޤȤƤѿ
 *		va_list argument;				ФѰʬNULLǽ
 *	֤
 *		ݥѿ
 *	
 *		VaCreateValuesLink() ʤɤǤޤȤ줿ѿѰͿ
 *		줿ѿФ
 *		
 *		
 * 			int argcount;
 *			va_list argument;
 *			PointorsLink linkBuffer;
 *			
 *			argcount = VGetValuesLink(&linkBuffer, argument);
 *		
 *	Ȼ
 *		VaCreatePointorsLink();		ѰʣĤΥݥѿޤȤ
 *		VaDestroyPointorsLink();	ѥݥ󥿥󥯤˴
 *		cutoffPointorsLink();		ѥݥ󥿥󥯤ǡФ
 *		
 *		PointorsLink ΥǡդƤϡstringuty.h 򻲾
 *		
 *	Хջ
 *		ѰǤݥ󥿤ϤȤ뤬ͤΥݥ
 *		NULLݥ󥿡ˤϡǡȤƼ̤뤿ϤȤ
 *		ʤݥѿμΤϤȤˤϡNULLˤʤʤȤǧ
 *		ƤʤȥХˤʤΤդɬס
 *		ݥ󥿤ϤȤˤϡΤΥ꤬Ϥ줿Ȥ¸ߤƤ
 *		Хˤʤޤ
 *		
 *		ʸʳǤϡƥ­Ǥ
 *		
 ***************************************************************************/
int VGetValuesLink(const PointorsLink *linkBuffer, va_list argument)
{
	int argc;						/* ѰʬθĿ */
	size_t argSize;					/* ΥХåե */
	void **argValue_ptr;			/* ; */
	const char *argType;			/*  */
	const PointorsLink *currentLink = 
							linkBuffer;	/* ꥹȤ³󥯥ݥ */

	argc = 0;							/* ʬθĿν */
	argType = (const char*)&argType;	/* NULLʳǤνɬ */

	while(argType != NULL) {
		/*  */
		argType = va_arg(argument, const char*);		/* ѰμФ */

		if(argType != NULL) {
			/* Ѱ³ʤ */
			++argc;
			argValue_ptr = va_arg(argument, void**);	/* ѰμФ */
			argSize  = va_arg(argument, size_t);		/* μФ */

			if(currentLink->type_pointer != NULL && *argType != '\0' && 
						*(currentLink->type_pointer) != '\0' && 
								strcmp(currentLink->typeName, argType)) {
				/***********************************************
				 *	̾ʸؤΥݥ󥿤 NULL or 
				 *	̾ʸ󤬶ʸξ硢ȽϤʤ
				 ***********************************************/
				fprintf(stderr, "Argument type is wrong!!\n");
				continue;
			}
#ifdef	OLD_IMPLEMENT
			switch(argSize) {
			case EOF:
				*argValue_ptr = XtMalloc(currentLink->bufferSize);
				memcpy(*argValue_ptr, 
					currentLink->data_ptr, currentLink->bufferSize);
				break;
			case 0:
				*argValue_ptr = currentLink->data_ptr;
				break;
			default:
				if(argSize > 0 && currentLink->bufferSize < argSize) {
					argSize = currentLink->bufferSize;
					memcpy(*argValue_ptr, currentLink->data_ptr, argSize);
				}
				break;
			}
#else
			switch(argSize) {
			case 0:
			case EOF:
				*argValue_ptr = getValuesLink(argSize, 
									*argValue_ptr, argType, currentLink);
				break;
			default:
				getValuesLink(argSize, 
							(void*)argValue_ptr, argType, currentLink);
				break;
			}
#endif	/*OLD_IMPLEMENT*/
			currentLink = currentLink->nextLink;
		}
	}
	return(argc);
}

/***************************************************************************
 *	VaGetValuesLink: ޤȤƤѿѰηʣļФ
 *	
 *		int VaGetValuesLink(const PointorsLink *linkBuffer, ...);
 *	
 *		const PointorsLink *linkBuffer;	ޤȤƤѿ
 *		...								ФѰʬNULLǽ
 *	֤
 *		ݥѿ
 *	
 *		VaCreateValuesLink() ʤɤǤޤȤƤѿѰη
 *		Ϳ줿ʣѿݥ󥿤ǼФ
 *		ΰʬϡ򼨤ʸͤΥݥ󥿡Ǥ
 *		ޤ
 *		
 *		򼨤ʸ
 *			XtRInt/XtRPointer/XtRString/XtRImmediate ѿ򼨤
 *			Ѥ߼̻ҤȽѤǤդʸѤǤޤ
 *			ʤXtRImmediate ̤ʰ̣äƤϤޤ󡣤
 *			åɬʤݥ󥿤ΥʲΥǡǡ
 *			쥯Ȥͤ¸ɤˤϡXtRImmediate Ѥ
 *			ʬˣꤷƲ
 *			ʤåɬפʤϡ"" Ѥ뤳ȤǤޤ
 *			Ĥޤ "" ѿȤꤷϡФΤȤ˹Ԥ
 *			åάޤ
 *		
 *		orͤΥݥϤ
 *			ʬˣꤷʤϡͤݥϤˤʤäƤ
 *			ȽǤޤξϡͤľϤȤ򼨤ޤ
 *			
 *		
 *			Хåեݤ¸륵򼨤ޤݥ󥿤
 *			ǤȤϡ򣰤ˤ롣
 *		
 *		ǡХåեʤξ
 *			
 *			 NULL or 
 *			ǡΤب
 *			ǡ
 *			 ̾ؤ  NULL 
 *			
 *			 ХåեĹ 
 *			
 *			ؤΥ󥯨 NULL 
 *			
 *			ؤΥ󥯨
 *			
 *			̾Хåե
 *			
 *			
 *			ǡХåեʤξϡإǡΤؤݥ󥿡ټΤ
 *			ݥ󥿤ϤΤ intʤɤѿѤˤѤޤ
 *			
 *		ǡХåեξ
 *			
 *			
 *			ǡΤب
 *			
 *			 ̾ؤ  NULL 
 *			
 *			 ХåեĹ 
 *			
 *			ؤΥ󥯨 NULL 
 *			
 *			ؤΥ󥯨
 *			
 *			̾Хåե
 *			
 *			Хåե
 *			
 *			
 *			ǡХåեξϡإǡΤؤݥ󥿡٤̾
 *			ХåեľꤷΥǡ򤳤ΰ֤˥ԡޤ
 *			ǡХåեʤξӤȤ;ʬʥ
 *			뤳Ȥˤʤޤ
 *		
 *		
 *			#define UserDefiniton "UserDefiniton"
 *			typedef ... UserDefiniton
 *			
 *			int num;
 * 			int argcount;
 *			int integerValue = 123;
 *			void *pinter1, *pointer2;
 *			UserDefiniton data;
 *			PointorsLink *linkBuffer;
 *			
 *			argcount = VaCreateValuesLink(&linkBuffer, 
 *							XtRInt,	&integerValue, 4, 	ġ
 *							XtRPointer, pointer1, 4, 	ġݥ󥿣
 *							XtRPointer, pointer2, 0, 	ġݥ󥿣
 *							XtRString, "string", EOF,	ġʸ
 *							XtRImmediate, 1234, 0, 		ġͤ쥯
 *							UserDefiniton, data, 
 *								sizeof(UserDefiniton), 	ġ桼 
 *							NULL);						ġλ
 *		
 *			argcount = VaGetValuesLink(&linkBuffer, 
 *							XtRInt,	&integerValue, 4, 	ġ
 *							XtRPointer, &pointer1, 4, 	ġݥ󥿣
 *							XtRPointer, &pointer2, 0, 	ġݥ󥿣
 *							XtRString, &string, EOF,	ġʸ
 *							XtRImmediate, &num, 0, 		ġͤ쥯
 *							UserDefiniton, &data, 
 *								sizeof(UserDefiniton), 	ġ桼 
 *							NULL);						ġλ
 *		
 *			ηδؿǤΰηåϡط򼨤ʸ٤ǹԤ
 *			ޤΤᡢXtRString ¸줿ǡФȤ 
 *			"char*" Ѥȥ顼ˤʤޤ
 *			"char*"  "char *" ζʸ㤤Ǥ⥨顼ˤʤޤ
 *	Ȼ
 *		VaCreateValuesLink();		ѰʣĤΥݥѿޤȤ
 *		VGetValuesLink();			
 *		VaDestroyPointorsLink();	ѥݥ󥿥󥯤˴
 *		cutoffPointorsLink();		ѥݥ󥿥󥯤ǡФ
 *		
 *		PointorsLink ΥǡդƤϡstringuty.h 򻲾
 *		
 *	Хջ
 *		ѰǤݥ󥿤ϤȤ뤬ͤΥݥ
 *		NULLݥ󥿡ˤϡǡȤƼ̤뤿ϤȤ
 *		ʤݥѿμΤϤȤˤϡNULLˤʤʤȤǧ
 *		ƤʤȥХˤʤΤդɬס
 *		ݥ󥿤ϤȤˤϡΤΥ꤬Ϥ줿Ȥ¸ߤƤ
 *		Хˤʤޤ
 *		
 ***************************************************************************/
int VaGetValuesLink(const PointorsLink *linkBuffer, ...)
{
	int argc;					/* ѰʬθĿ */
	va_list argument;

	va_start(argument, linkBuffer);		/* ѰΤ */

	argc = VGetValuesLink(linkBuffer, argument);

	va_end(argument);					/* Ѱ˴ؤ */

	return(argc);
}

/***************************************************************************
 *	VaGetAbsValuesLink: а֤ǻꤷֹ椫ͤ˼
 *	
 *		int VaGetAbsValuesLink(const PointorsLink *linkBuffer, int step, ...);
 *	
 *		const PointorsLink *linkBuffer;	ݥ󥿥
 *		int step;						ֹ
 *	֤
 *		ǡ
 *	
 *		
 ***************************************************************************/
int VaGetAbsValuesLink(const PointorsLink *linkBuffer, int step, ...)
{
	int argc = 0;					/* ѰʬθĿ */
	va_list argument;

	va_start(argument, step);		/* ѰΤ */

	linkBuffer = (PointorsLink*)terminalSearch(linkBuffer, prevPointersLink);
	linkBuffer = 
		(const PointorsLink*)numSearch(linkBuffer, step, nextPointersLink);
	if(linkBuffer != NULL) {
		argc = VGetValuesLink(linkBuffer, argument);
	}

	va_end(argument);					/* Ѱ˴ؤ */

	return(argc);
}

/***************************************************************************
 *	VaGetRelValuesLink: а֤ǻꤷֹ椫ͤ˼
 *	
 *		int VaGetRelValuesLink(const PointorsLink *linkBuffer, int step, ...);
 *	
 *		const PointorsLink *linkBuffer;
 *		int step;
 *	֤
 *		
 *	
 *		ƬΥ󥯤ɤä
 *		
 *		ǡ¤ΤƬ
 *		 NULL or 
 *		ǡΤب
 *		ǡ
 *		 ̾ؤ  NULL 
 *		
 *		 ХåեĹ 
 *		
 *		ؤΥ󥯨 NULL 
 *		
 *		ؤΥ󥯨
 *		
 *		̾Хåե
 *		
 *		Хåե
 *		
 *		
 *		
 *		 NULL or 
 *		ǡΤب
 *		ǡ
 *		 ̾ؤ  NULL 
 *		
 *		 ХåեĹ 
 *		
 *		ؤΥ󥯨
 *		
 *		ؤΥ󥯨
 *		
 *		̾Хåե
 *		
 *		Хåե
 *		
 *		
 *		
 ***************************************************************************/
int VaGetRelValuesLink(const PointorsLink *linkBuffer, int step, ...)
{
	int argc = 0;					/* ѰʬθĿ */
	va_list argument;
	const void *(*linkStep[2])(const void *pointer) = 
							{prevPointersLink, nextPointersLink};

	va_start(argument, step);		/* ѰΤ */

	linkBuffer = (const PointorsLink*)
					numSearch(linkBuffer, step, linkStep[(step >= 0)]);
	if(linkBuffer != NULL) {
		argc = VGetValuesLink(linkBuffer, argument);
	}

	va_end(argument);					/* Ѱ˴ؤ */

	return(argc);
}

/***************************************************************************
 *	VaCountPointorsLink: 󥯤κǽ餫ǸޤǤΥ󥯿򥫥Ȥ
 *	
 *		int VaCountPointorsLink(PointorsLink *linkBuffer);
 *	
 *		PointorsLink *linkBuffer;
 *	֤
 *		ǽ餫ǸޤǤΥ󥯿
 *	
 *		
 ***************************************************************************/
int VaCountPointorsLink(PointorsLink *linkBuffer)
{
	int counter = 0;

	while(linkBuffer != NULL && linkBuffer->prevLink != NULL) {
		linkBuffer = linkBuffer->prevLink;
	}
	while(linkBuffer != NULL) {
		++counter;
		linkBuffer = linkBuffer->nextLink;
	}
	return(counter);
}

/***************************************************************************
 *	VaDestroyPointorsLink: ѤΥǸޤ˴
 *	
 *		void VaDestroyPointorsLink(PointorsLink *linkBuffer);
 *	
 *		PointorsLink *linkBuffer;	˴ʲˤѤΥ
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void VaDestroyPointorsLink(PointorsLink *linkBuffer)
{
	PointorsLink *release_ptr;

	while(linkBuffer != NULL && linkBuffer->prevLink != NULL) {
		linkBuffer = linkBuffer->prevLink;
	}
	while(linkBuffer != NULL) {
		release_ptr = linkBuffer;
		linkBuffer = linkBuffer->nextLink;
		XtFree((char*)release_ptr);
	}
}

/***************************************************************************
 *	cutoffPointorsLink: ѥݥ󥿥󥯥ꥹȤǡФ
 *	
 *		void *cutoffPointorsLink(PointorsLink **linkBuffer);
 *	
 *		PointorsLink **linkBuffer;
 *	֤
 *		NULL:		Ф̵ͤʤǤ˼ФƤ
 *		NULLʳ:	󥯥ꥹȵϿƤݥ󥿡ʤν˴줿
 *	
 *		ѥݥ󥿥󥯥ꥹȤꤵ줿ΥǡȴФ
 *		Ūˤϡ
 *		ѥݥ󥿥󥯥ꥹȤͭǤСξݥ󥿥ꥹȤ
 *		ڤΥϿƤݥ󥿤֤
 *		
 ***************************************************************************/
void *cutoffPointorsLink(PointorsLink **linkBuffer)
{
	void *result_ptr = NULL;
	PointorsLink *release_ptr;

	if(linkBuffer != NULL && *linkBuffer != NULL) {
		release_ptr = *linkBuffer;
		result_ptr  = release_ptr->data_ptr;
		*linkBuffer = release_ptr->nextLink;
		if(*linkBuffer != NULL) {
			(*linkBuffer)->prevLink = NULL;
		}
		XtFree((char*)release_ptr);
	}
	return(result_ptr);
}

